	PROGRAM APIT1
C
C PROGRAM TO GENERATE RANDOM N-TUPLE AND HISTOGRAM DATA AND DEMONSTRATE
C	 ADVANCED FEATURES OF HISTO-SCOPE WITH NEW API
C
	IMPLICIT NONE
C#include "histoscope.inc"
C
C   IF COMPILING PROGRAM ON VMS OR IBM/AIX SYSTEM, COMMENT OUT
C   ABOVE INCLUDE AND REMOVE THE C IN COLUMN 1 OF NEXT ONE
C
	INCLUDE 'histoscope.inc'
	INTEGER I, J, K, N_VARIABLES, HS1_ID, HS2_ID, NTUPLE_ID
	INTEGER NT2, NT3
	INTEGER CTRL_ID, IND_ID, CTRL_NPTS_ID, CTRL_MERRS_ID
	INTEGER TRIGGER_ID, NUM_PTS, ISTAT
	REAL VALUES(8), CVAL, FVALPTS, ERRVAL_M
	REAL ERRS1D(100), ERRS2D(10000), ERRS1D_M(100), ERRS2D_M(10000)
	REAL RNDOM
	CHARACTER*8 TAGS(8), TAGS_V
	CHARACTER*80 TITLE, CATEGORY

	INTEGER LISTGD(1000), I40, I55, I74, UID, II, I905, I5106, JJ
	INTEGER NUMGD, NNX, NNY
	INTEGER NUM678
	PARAMETER (NUM678 = 678)
	
	REAL VAL1D_1(100), VAL1D_2(100), ERR1D_P(100), ERR1D_M(100)
	REAL VAL2D_1(100,25), VAL2D_2(100,25)
	REAL ERR2D_P(100,25)
	REAL XMIN, XMAX, YMIN, YMAX, XB, YB, OVERFLOWS(3,3), VALT
        REAL YVALT, COLUMN5(1000), ALLDATA(NUM678,8)
        
        EXTERNAL BCOPY, BZERO
	
	N_VARIABLES = 8
	NUM_PTS = 10000
        TAGS(1) = 'X'
        TAGS(2) = 'Y'
        TAGS(3) = 'IDX'
        TAGS(4) = 'SQRT(X)'
        TAGS(5) = 'SQRT(Y)'
        TAGS(6) = 'LOG(X)'
        TAGS(7) = 'LOG(Y)'
        TAGS(8) = 'SIN(IDX)'
	call bcopy
	call bzero        
	CALL HS_INITIALIZE('APIT1')
 	NT2 = HS_CREATE_NTUPLE(41,'EXAMPLE NTUPLE, ITTER 2', 'HS',
     &      N_VARIABLES, TAGS)
 	NT3 = HS_CREATE_NTUPLE(42,'EXAMPLE NTUPLE, ITTER 3', 'HS',
     &      N_VARIABLES, TAGS)
 	HS1_ID = HS_CREATE_1D_HIST(-55, 'EXAMPLE 1D HIST', 'HS', 'Y',
     &      'TOTAL' ,100, 4600., 5400.)
 	HS2_ID = HS_CREATE_2D_HIST(-74,'2D HIST EXAMPLE', 'HS','X', 'Y',
     &      'TOTAL', 100, 25, 4600., 5400., 4650., 5250.)
	IND_ID = HS_CREATE_INDICATOR(102,'INDICATOR EXAMPLE', 'HS', 0.,
     &      10000.)
	CTRL_ID = HS_CREATE_CONTROL(103,
     &      'CONTROL: PAUSE IF .LT. 0', 'HS',
     &      -500., +500., 0.)
	CTRL_NPTS_ID = HS_CREATE_CONTROL(104,'CONTROL: NUM OF PTS', 'HS',
     &      0., 10000., 10000.)
	CTRL_MERRS_ID = HS_CREATE_CONTROL(108,
     &      'CONTROL: SET SYSTEMATIC ERRS', 'HS', 0., 1., 0.)
	TRIGGER_ID = HS_CREATE_TRIGGER(109,'TRIGGER EXAMPLE', 'HS')
C

	TITLE = 'JUNKY STUFF, LOOK AT NUMBERS  XXXX  -- XX '
C		 123456789012345678901234567890123456789012345
	DO I = 40,60
	 DO J = 1,5
	   UID = 150 000 + I*100 + J
	   WRITE (TITLE(31:34), '(I4.4)') I
	   WRITE (TITLE(40:41), '(I2.2)') J
	   II = HS_CREATE_1D_HIST(UID, TITLE, 'JUNK1', 'Y',
     &      'TOTAL' ,100, 4600., 5400.)
 	END DO
       END DO
       
       PRINT *, 'CALLING HS_LIST_ITEMS JUST AFTER CREATE'
	NUMGD = HS_LIST_ITEMS('0051','JUNK1', LISTGD, 15, 1)
	PRINT *, ' NUMGD FOUND ', NUMGD

c
c	Attempting to define a histogram by same uid/Category
c
	do i = 1,10
	  call hs_update
	end do

	print *, ' Type some number to keep going '
	print *, ' If negativ, jump immediately to Ntuple studies'
	read(5,*) II
	if (II .LT. 0) GOTO 71
	
    	CALL HS_FILL_1D_HIST(HS1_ID, 4880., 50.)
	II =  HS_ID(155002,'JUNK1') 
	PRINT *, ' II FROM HS_ID, JUNK1, CLASS 50, -2 ', II 
	
        CALL HS_FILL_1D_HIST(II, 4880., 5.)
    	    
	do i = 1,100
          CALL HS_FILL_1D_HIST(HS1_ID, 4880. + i*2., 5.)
	  call hs_update
	end do
	
	DO I = 1,3
          CALL HS_FILL_1D_HIST(HS1_ID, 47000., 1.)
	END DO 

	DO I = 1,2
          CALL HS_FILL_1D_HIST(HS1_ID, -47000., 1.)
	END DO 
		
	 UID = 155003
	
	   II = HS_CREATE_1D_HIST(UID, 'Duplicate', 'JUNK1', 'Y',
     &      'TOTAL' ,100, 4600., 5400.)
        
	PRINT *, ' Trying to create duplicate uid/category', II 
	
	   II = HS_CREATE_1D_HIST(-888, 'BadCat', 'JU...NK1', 'Y',
     &      'TOTAL' ,100, 4600., 5400.)
	PRINT *, ' Trying to create item with bad category', II 
        
        II = HS_ID(UID,'JUNK1')
	CALL HS_CHANGE_CATEGORY(II,'NEWJUNK1')
	 
	II = HS_ID(154002,'JUNK1')
	CALL
     &    HS_CHANGE_TITLE(II, ' Whoa, I got a new title for this dude!')
      
 	DO I = 1,2
          CALL HS_FILL_1D_HIST(II, -47000., 1.)
          CALL HS_UPDATE
	END DO 
     
	print *, ' Type some number to keep going '
	read(5,*) II
	
 	DO I = 1,2
          CALL HS_FILL_1D_HIST(HS1_ID, -47000., 1.)
	END DO 
      
c
c	Checking the Item acces routines.. 
c
	PRINT *, ' NUMBER OF ITEMS ', HS_NUM_ITEMS()
	
	I74 = HS_ID(-74,'HS') 
	PRINT *, ' I74 ', I74
	I905 = HS_ID(350905,'JUNK1') 
	PRINT *, ' I905 ', I905
	I5106 = HS_ID((150 000 + 5106),'JUNK1')
	PRINT *, ' I5106 ', I5106
	
	TITLE = 'JUNKY STUFF, LOOK AT NUMBERS  0041  -- 03 '
	i5106 = HS_ID_FROM_TITLE(TITLE,'JUNK1')
	PRINT *, 'Should be found: I4103, by title ', I5106
	
	NUMGD = HS_LIST_ITEMS(TITLE, 'JUNK1', LISTGD, 15, 0)
	PRINT *, 'Exact HS_LIST_ITEMS: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
	
	TITLE = 'JUNKY STUFF, LOOK AT NUMBERS  0051  -- 06 '
	i5106 = HS_ID_FROM_TITLE(TITLE,'JUNK1')
	PRINT *, 'Not to be found: I5106, by title ', I5106
	
	NUMGD = HS_LIST_ITEMS('0051','JUNK1', LISTGD, 15, 1)
	PRINT *, ' NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
	
C	DO II = 1,5
C	  CALL HS_DELETE(LISTGD(II))
C	END DO
	CALL HS_DELETE_ITEMS(LISTGD, 5)
	
	PRINT *, ' NUMBER OF ITEMS ', HS_NUM_ITEMS()
	
	PRINT *, 'I DELETED ALL 5, SO NOW NONE SHOULD BE FOUND'
	NUMGD = HS_LIST_ITEMS('0051','JUNK1', LISTGD, 15, 1)
	PRINT *, ' NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
C	DO II = 1,NUMGD
C	  CALL HS_DELETE(LISTGD(II))
C	END DO
	CALL HS_DELETE_ITEMS(LISTGD, NUMGD)
	
	NUMGD = HS_LIST_ITEMS('0052','JUNK1', LISTGD, 15, 1)
	PRINT *, ' NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
c
c	More simple exercises : hs_uid, category, title, type.
c
	UID = HS_UID(LISTGD(1))
	PRINT *, ' UID for listdg(1) ', UID
	
	UID = HS_UID(5672145)
	PRINT *, ' UID for crappy number ', UID
	
	II = HS_CATEGORY(LISTGD(1), CATEGORY)
	PRINT *, 'Category, return value ' ,  CATEGORY(1:II), II
	
	II = HS_CATEGORY(0, CATEGORY)
	PRINT *, 'Category return for crap' , II
	
	II = HS_CATEGORY(-57457, CATEGORY)
	PRINT *, 'Category return for crap' , II
	
	II = HS_TITLE(LISTGD(1), TITLE)
	PRINT *, 'Title ' , TITLE(1:II)
	
	II = HS_TITLE(-57457, TITLE)
	PRINT *, 'Title return for crap' , II
	
	II = HS_TYPE(LISTGD(1))
	PRINT *, 'TYPE for Junk1 1-D histo ' , II 
	
	II = HS_TYPE(NT2)
	if (II .NE. HS_NONE) THEN 
		PRINT *, 'TYPE for Ntuple histo ' , II
	ELSE 
	  PRINT *, ' This item does not exist or has been deleted'
	END IF

         PRINT *, 'HS_TYPE SHOULD NOT FIND ANYTHING NEXT:'
	II = HS_TYPE(304965)
	if (II .NE. HS_NONE) THEN 
		PRINT *, 'TYPE for Ntuple histo ' , II
	ELSE 
	  PRINT *, ' This item does not exist or has been deleted'
	END IF
c -------------------------------------------------------------
C
	print *, ' Type some number to keep going '
	read(5,*) II
	IF (II .LT. 0) GOTO 41
c
c	Checking now the Block Filling... 
c
	DO I = 1,100
	  VAL1D_1(I) = I*5.
	  ERR1D_P(I) = SQRT(VAL1D_1(I))
	END DO
	II = HS_ID(154001, 'JUNK1')
	CALL HS_1D_HIST_BLOCK_FILL(II, VAL1D_1, ERR1D_P, %VAL(0) )
	print *, ' Expect error:'
	CALL HS_1D_HIST_BLOCK_FILL(NT2, VAL1D_1, %VAL(0), %VAL(0))
	 
	DO I = 1,100
	  DO J = 1,25
	   VAL2D_1(I,J) = I*5. + J*100.
	   ERR2D_P(I,J) = SQRT(VAL2D_1(I,J))
	  END DO
	END DO
	CALL HS_2D_HIST_BLOCK_FILL(HS2_ID, VAL2D_1, ERR2D_P, %VAL(0) )
	
	CALL HS_UPDATE
	CALL HS_UPDATE
	
	print *, ' Type some number to keep going '
	read(5,*) II
	
	CALL HS_UPDATE
	CALL HS_UPDATE
	
	print *, ' Type some number to keep going '
	read(5,*) II
	IF (II .LT. 0) GOTO 41
C
C -----------------------------------------------------------------
C
C
c		Testing moronic interface routines..1D, then 
c		2D...
c
	PRINT *, ' NUMBER OF CHANNEL FOR 1D HISTOGRAM ', HS1_ID,
     &          ' = ' , HS_1D_HIST_NUM_BINS(HS1_ID)
        CALL HS_1D_HIST_RANGE(HS1_ID, XMIN, XMAX)
        PRINT *, ' RANGES ARE ', XMIN, XMAX
        PRINT *, ' NUM ENTRIES ', HS_NUM_ENTRIES(HS1_ID)
	II = HS_ID(154001, 'JUNK1')
        CALL HS_1D_HIST_BIN_CONTENTS(II, VAL1D_2)
        PRINT *, ' TESTING CONTENT.. '
        DO I = 1, HS_1D_HIST_NUM_BINS(II)
          IF (VAL1D_1(I) .NE. VAL1D_2(I))
     &     PRINT *, ' ERROR IN RETRIEVING VALUES FROM 1D HISTO'
     	END DO
        I = HS_1D_HIST_ERRORS(II, VAL1D_2, %VAL(0))
        DO I = 1, HS_1D_HIST_NUM_BINS(II)
          IF (ERR1D_P(I) .NE. VAL1D_2(I))
     &     PRINT *, ' ERROR IN RETRIEVING ERRORS FROM 1D HISTO'
     	END DO
     	CALL HS_1D_HIST_OVERFLOWS(HS1_ID, XMIN, XMAX)
     	PRINT *,
     & ' UNDERFLOW AND OVERFLOWS FOR HS1_ID ARE ', XMIN, XMAX
        XB = 4880.
        PRINT *, ' FOR HISTOGRAM ', HS1_ID, ' VALUE AT X ', XB, 
     &  'IS ', HS_1D_HIST_X_VALUE(HS1_ID, XB)
        PRINT *, ' FOR HISTOGRAM ', HS1_ID 
        do ii = 30, 40 
          PRINT *, ' VALUE AT BIN # ', II, 
     &  '  IS  ', HS_1D_HIST_BIN_VALUE(HS1_ID, II)
        END DO
c
	print *, ' Type some number to keep going '
	read(5,*) II
	IF (II .LT. 0) GOTO 41

	DO II = 1,8
	 DO I = 1,II
	  IF (II .EQ. 1) CALL HS_FILL_2D_HIST(HS2_ID, 3., 3., 1.)
	  IF (II .EQ. 2) 
     &        CALL HS_FILL_2D_HIST(HS2_ID, 3., 5000., 1.)
	  IF (II .EQ. 3) 
     &        CALL HS_FILL_2D_HIST(HS2_ID, 3., 10000., 1.)
	  IF (II .EQ. 4) 
     &        CALL HS_FILL_2D_HIST(HS2_ID, 5000., 10000., 1.)
	  IF (II .EQ. 5) 
     &        CALL HS_FILL_2D_HIST(HS2_ID, 30000., 30000., 1.)
	  IF (II .EQ. 6) 
     &        CALL HS_FILL_2D_HIST(HS2_ID, 30000., 5000., 1.)
	  IF (II .EQ. 7) 
     &        CALL HS_FILL_2D_HIST(HS2_ID, 30000., 3., 1.)
	  IF (II .EQ. 8) 
     &        CALL HS_FILL_2D_HIST(HS2_ID, 5000., 3., 1.)
 	 END DO
	END DO

	CALL HS_2D_HIST_NUM_BINS(HS2_ID, NNX, NNY)
	PRINT *, ' NUMBER OF CHANNEL FOR 2D HISTOGRAM ', HS2_ID,
     &          ' = ' , NNX, NNY

	PRINT *, ' Expect error next:'
	CALL HS_2D_HIST_NUM_BINS(HS1_ID, NNX, NNY)

        CALL HS_2D_HIST_RANGE(HS2_ID, XMIN, XMAX, YMIN, YMAX)
        PRINT *, ' X RANGES ARE ', XMIN, XMAX
        PRINT *, ' Y RANGES ARE ', YMIN, YMAX
        PRINT *, ' NUM ENTRIES ', HS_NUM_ENTRIES(HS2_ID)
        CALL HS_2D_HIST_BIN_CONTENTS(HS2_ID, VAL2D_2)
        PRINT *, ' TESTING CONTENT.. '
        DO I = 1, NNX
         DO J = 1,NNY
          IF (VAL2D_1(I,J) .NE. VAL2D_2(I,J))
     &     PRINT *, ' ERROR IN RETRIEVING VALUES FROM 2D HISTO'
     	 END DO
	END DO
        I = HS_2D_HIST_ERRORS(HS2_ID, VAL2D_2, %VAL(0))
        DO I = 1,NNX
	 DO J = 1,NNY
          IF (ERR2D_P(I,J) .NE. VAL2D_2(I,J))
     &     PRINT *, ' ERROR IN RETRIEVING ERRORS FROM 2D HISTO'
     	 END DO
	END DO
     	CALL HS_2D_HIST_OVERFLOWS(HS2_ID, OVERFLOWS)
     	PRINT *,
     & ' OVERFLOWS FOR 2 D HISTO '
	DO I = 1,3
          PRINT *, ' I = ', I, (OVERFLOWS(I,J), J=1,3)
	END DO

	print *, ' Type some number to keep going '
	IF (II .LT. 0) GOTO 41
	read(5,*) II

	XB = 4880.
	YB = 5000.
        PRINT *, ' 2D HISTO, VALUE AT X,Y ', XB,YB, 
     &  'IS ', HS_2D_HIST_XY_VALUE(HS2_ID, XB, YB)
        PRINT *, ' FOR HISTOGRAM ', HS2_ID 
        do i = 35, 40
	 DO J = 2,3 
          PRINT *, ' VALUE AT BIN # ', I, J, 
     &  '  IS  ', HS_2D_HIST_BIN_VALUE(HS2_ID, I, J)
          END DO
	END DO
C
	print *, ' Type some number to keep going '
	read(5,*) II
        
 41     CONTINUE     
c	Testing some file I/O capability.. 
C	
	ISTAT = HS_SAVE_FILE('t1_t.hst')
	

	print *, ' Type some number to keep going '
	read(5,*) II
	
	        
	NUMGD = HS_LIST_ITEMS('0050','JUNK1', LISTGD, 15, 1)
	PRINT *, ' NUMGD FOUND before first read ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
c
c	Select by Category and uid.. 
c
	DO J = 1,5
	  LISTGD(J) = 155000 + J
	END DO
	 
	II = 
     &  HS_READ_FILE_ITEMS('t1_t.hst', 'try1', 'JUNK1',  LISTGD, 5 )
        print *, ' Return code after hs_read_file_item ', II
        
	TITLE = 'JUNKY STUFF, LOOK AT NUMBERS  0050  -- 01 '
	PRINT *, 'TITLE = ', TITLE
	
	NUMGD = HS_LIST_ITEMS(TITLE, 'try1', LISTGD, 15, 0)
	PRINT *, 'Exact HS_LIST_ITEMS try1: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
	
	NUMGD = HS_LIST_ITEMS(TITLE, 'try1/...', LISTGD, 15, 0)
	PRINT *, 'Exact HS_LIST_ITEMS try1/...: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
        
	NUMGD = HS_LIST_ITEMS(TITLE, 'try1/JUNK1', LISTGD, 15, 0)
	PRINT *, 'Exact HS_LIST_ITEMS try1/JUNK1: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)

	NUMGD = HS_LIST_ITEMS(' ', 'try1', LISTGD, 150, 1)
	PRINT *, 'HS_LIST_ITEMS try1: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
	
	NUMGD = HS_LIST_ITEMS(' ', 'try1/...', LISTGD, 150, 1)
	PRINT *, 'HS_LIST_ITEMS try1/...: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
        
	NUMGD = HS_LIST_ITEMS(' ', 'try1...', LISTGD, 150, 1)
	PRINT *, 'HS_LIST_ITEMS try1...: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
        
	NUMGD = HS_LIST_ITEMS(' ', 'try1/JUNK1', LISTGD, 150, 1)
	PRINT *, 'HS_LIST_ITEMS try1/JUNK1: NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)

	NUMGD = HS_LIST_ITEMS(' ', '...', LISTGD, 900, 1)
	PRINT *, 'List Everything: ... : NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)

	print *, ' Type some number to keep going '
	read(5,*) II
	
	II = HS_READ_FILE('D_anal_4267.hs', '4267_')
        print *, ' Return code after hs_read_file ', II
        
	do i = 1,10
	  call hs_update
	end do
	
	        
	NUMGD = HS_LIST_ITEMS('0050','try1/JUNK1', LISTGD, 15, 1)
	PRINT *, ' NUMGD FOUND from try1 ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
        
	NUMGD = HS_LIST_ITEMS(' ','4267_/Tracking', LISTGD, 15, 1)
	PRINT *, ' Selection 4267_, Tracking, NUMGD FOUND ', NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
c
c	Finding out some non-trivial properties about the first histo
c	of this list...
c
	TITLE = ' '
	ISTAT = HS_TITLE(LISTGD(NUMGD), TITLE)
	PRINT *, ' EXTREMUM PROPERTIES OF HISTO ID #' , LISTGD(NUMGD)
	PRINT *, TITLE 
	CALL HS_1D_HIST_MINIMUM(LISTGD(NUMGD), XB, II, VALT)
	PRINT *, ' Minimum at X-loc, bin #, values ', XB, II, VALT 
	CALL HS_1D_HIST_MAXIMUM(LISTGD(NUMGD), XB, II, VALT)
	PRINT *, ' Maximum at X-loc, bin #, values ', XB, II, VALT 
	CALL HS_1D_HIST_STATS(LISTGD(NUMGD), XB, VALT)
	PRINT *, ' Average and variance ', XB, VALT
	PRINT *, ' Integral ', HS_HIST_INTEGRAL(LISTGD(NUMGD))
	
	TITLE = ' '
	ISTAT = HS_TITLE(HS2_ID, TITLE)
	PRINT *, ' EXTREMUM PROPERTIES OF HISTO ID #' , HS2_ID
	PRINT *, TITLE 
	CALL HS_2D_HIST_MINIMUM(HS2_ID, XB, YB, II, JJ, VALT)
	PRINT *, ' Minimum at X-loc, bin #, values '
	PRINT *,  XB, YB,  II, JJ, VALT 
	CALL HS_2D_HIST_MAXIMUM(HS2_ID, XB, YB, II, JJ, VALT)
	PRINT *, ' Maximum at X-loc, bin #, values '
	PRINT *,  XB, YB,  II, JJ, VALT
	CALL HS_2D_HIST_STATS(HS2_ID, XB, YB, VALT, YVALT)
	PRINT *, ' Average and variance, X axis ', XB, VALT
	PRINT *, ' Average and variance, Y axis ', YB, YVALT
	PRINT *, ' Integral ', HS_HIST_INTEGRAL(HS2_ID)
	 
	PRINT *, ' NUMBER OF ITEMS ', HS_NUM_ITEMS()
	
	print *, ' Type some number to keep going '
	read(5,*) II
c
c	Checking of the arythmetic operations on Histogram. Start with 
c	addition.
c
	II = HS_SUM_HISTOGRAMS(-878, 'renormalisation of NUMTRA', 
     &              '4267_/Tracking', LISTGD(NUMGD), 0, 0.50, 0.)
        call hs_update
	II = HS_SUM_HISTOGRAMS(-879, 'RANDOM of NUMTRA', 
     &          '4267_/Tracking', LISTGD(NUMGD), LISTGD(1), 0.50, 1.)
	NUMGD = HS_LIST_ITEMS('Mass 4pi, wide',
     &                '4267_/Four_pions-4', LISTGD, 15, 1)
        PRINT *, ' NUMGD FOR Four_pions-4 ', NUMGD
        DO I = 1,NUMGD
          CALL HS_CHANGE_UID(LISTGD(I), (1000 + I*5))
        END DO
        TITLE = ' '
	II = HS_TITLE(LISTGD(1), TITLE)
        PRINT *, ' TITLE, first ', TITLE
        TITLE = ' '
	II = HS_TITLE(LISTGD(2), TITLE)
        PRINT *, ' TITLE, second ', TITLE
        CALL HS_HIST_SET_GAUSS_ERRORS(LISTGD(1))
     
	II = HS_SUM_HISTOGRAMS(-880, 'RANDOM sum of Mass 4pi', 
     &      '4267_/Four_pions-4', LISTGD(1), LISTGD(2), 1.0, 1.)
        
	II = HS_MULTIPLY_HISTOGRAMS(-881, 'RANDOM multiply of Mass 4pi', 
     &      '4267_/Four_pions-4', LISTGD(1), LISTGD(2), 0.01)
         
	II = HS_DIVIDE_HISTOGRAMS(-882, 'RANDOM divide of Mass 4pi', 
     &      '4267_/Four_pions-4', LISTGD(1), LISTGD(2), 1.0)
     
        
c
c	Let us make sure I have a chance to see what's going on 
c	before Category deletion.. 
c
        call hs_update
	print *, ' Type some number to keep going '
	read(5,*) II
        call hs_update
        
        call hs_update
	print *, ' Type some number to keep going '
	read(5,*) II
        call hs_update
        
        call hs_update
	print *, ' Type some number to keep going '
	read(5,*) II
        call hs_update
        
	NUMGD = 5
	DO J = 1,NUMGD
	  LISTGD(J) = 155000 + J
	  PRINT *, ' HS_ID FOR UID IN JUNK1, BEFORE DELETION OF 4267_', 
     &       HS_ID(LISTGD(J),'JUNK1'), LISTGD(J)
	END DO
	
	CALL HS_DELETE_CATEGORY('4267_/Tracking')
	
	PRINT *, ' NUMBER OF ITEMS ', HS_NUM_ITEMS()
	
	NUMGD = HS_LIST_ITEMS(' ','4267_/Tracking', LISTGD, 15, 1)
	PRINT *,
     & ' AFER DELETION, Selection 4267_, Tracking, NUMGD FOUND ', 
     &   NUMGD
	PRINT *,' LISTGD 1-20 ', (LISTGD(II), II = 1,NUMGD)
		
c	
c
c	Save to file again, specifying some histo we want.. 
c
	II = HS_SAVE_FILE_ITEMS('t1_4267.hst', '4267_/Four_pions-4',
     &          LISTGD, 0)
     
        PRINT *,
     &   ' RETURN CODE FROM SAVE_FILE_ITEM, 4267 Four_pions-4 ', II 
c
	NUMGD = 5
	DO J = 1,NUMGD
	  LISTGD(J) = 155000 + J
	  PRINT *, ' HS_ID FOR UID IN JUNK1', 
     &       HS_ID(LISTGD(J),'JUNK1'), LISTGD(J)
	END DO
	 
	PRINT *, ' Attempting to write ', NUMGD, ' items... '
	II = HS_SAVE_FILE_ITEMS('t2_t.hst','JUNK1', LISTGD, NUMGD)
        PRINT *,' RETURN CODE FROM SAVE_FILE_ITEM, JUNK1, BUNCH 50', II
        
         
	do i = 1,10
	  call hs_update
	end do

	print *, ' Type some number to keep going '
	read(5,*) II
 71     CONTINUE
c
C	Testing now the access routines for NTuple. Choose non-Random 
C	data to verify content. Start by accessing static properties...
c
	NTUPLE_ID = HS_ID(41,'HS')
	PRINT *, ' Number of Variables for NTuple, ',  NTUPLE_ID ,
     &  '    .. IS .. ', HS_NUM_VARIABLES(NTUPLE_ID)
	I = HS_VARIABLE_NAME(NTUPLE_ID, 5, TAGS_V)
	PRINT *, ' 5TH variable has the following name : ', TAGS_V
	PRINT *, '   and the SQRT(X) variable is in column ', 
     &     HS_VARIABLE_INDEX(NTUPLE_ID,'SQRT(X)')
     
       DO I = 1,NUM678
         VALUES(1) = 0.01*I
         VALUES(2) = 0.1*I
         VALUES(3) = I
         VALUES(4) = SQRT(VALUES(1))
         VALUES(5) = SQRT(VALUES(2))
         VALUES(6) = LOG(VALUES(1))
         VALUES(7) = LOG(VALUES(2))
         IF (I .LT. 535) THEN 
           ISTAT = HS_FILL_NTUPLE(NT2, VALUES)
         ELSE 
           ISTAT = HS_FILL_NTUPLE(NT3, VALUES)
         END IF
       END DO
       CALL HS_UPDATE
       NTUPLE_ID = HS_MERGE_ENTRIES(40, ' Example Ntuple, Merged ',
     &                   'HS', NT2,NT3)
	NTUPLE_ID = HS_ID(40,'HS')
	PRINT *, ' Number of Variables for NTuple, ',  NTUPLE_ID ,
     &  '    .. IS .. ', HS_NUM_VARIABLES(NTUPLE_ID)
	I = HS_VARIABLE_NAME(NTUPLE_ID, 5, TAGS_V)
	PRINT *, ' 5TH variable has the following name : ', TAGS_V
	PRINT *, '   and the SQRT(X) variable is in column ', 
     &     HS_VARIABLE_INDEX(NTUPLE_ID,'SQRT(X)')
       CALL HS_UPDATE
       PRINT *, ' NUMBER OF ENTRIES IN NTUPLE ',
     &                 HS_NUM_ENTRIES(NTUPLE_ID)
       PRINT *, ' Value for 3th entry, column 4 ', 
     &           HS_NTUPLE_VALUE(NTUPLE_ID, 3, 4)
       PRINT *, ' Value for 150th entry, column 5 ', 
     &           HS_NTUPLE_VALUE(NTUPLE_ID, 150, 5)
       PRINT *, ' Value for 678th entry, column 4 ', 
     &           HS_NTUPLE_VALUE(NTUPLE_ID, 678, 4)
     
       CALL HS_ROW_CONTENTS(NTUPLE_ID, 3, VALUES)
       PRINT *, ' For Entry 3, values (1-5) '
       PRINT *, (VALUES(II), II = 1,5) 
       CALL HS_ROW_CONTENTS(NTUPLE_ID, 677, VALUES)
       PRINT *, ' For Entry 677, values (1-5) '
       PRINT *, (VALUES(II), II = 1,5) 
       CALL HS_ROW_CONTENTS(NTUPLE_ID, 679, VALUES)
       
       CALL HS_COLUMN_CONTENTS(NTUPLE_ID, 5, COLUMN5)
       PRINT *, ' Column 5 for entry 675-678 ' 
       PRINT *, (COLUMN5(II), II = 675,678)
       PRINT *, ' Column 5 for entry 3-6 ' 
       PRINT *, (COLUMN5(II), II = 3,6)
       
       CALL HS_NTUPLE_CONTENTS(NTUPLE_ID, ALLDATA)
       PRINT *, ' From all data, content of entries 675, column 3'
       PRINT *, ALLDATA(675,3)
       PRINT *, ' From all data, content of entries 3, column 3'
       PRINT *, ALLDATA(3,3)
         
     	               
C
C	    RANDOM DATA COMPUTATION - THIS COULD BE ANY CODE YOU WISH
C
	I = 1
	DO WHILE (I .LE. NUM_PTS)
    	    DO J = 1, 2
    		VALUES(J) = 0
    		DO K = 1, 1000
    	    	    VALUES(J) = VALUES(J) + RNDOM() * 10.
    		ENDDO
    	    ENDDO
    	    
    	    VALUES(3) = I
    	    VALUES(4) = SQRT(VALUES(1))
    	    VALUES(5) = SQRT(VALUES(2))
    	    VALUES(6) = LOG(VALUES(1))
    	    VALUES(7) = LOG(VALUES(2))
    	    VALUES(8) = SIN(VALUES(3))

    	    ISTAT = HS_FILL_NTUPLE(NTUPLE_ID, VALUES)
    	    CALL HS_FILL_1D_HIST(HS1_ID, VALUES(2), 1.)
    	    CALL HS_FILL_2D_HIST(HS2_ID, VALUES(1), VALUES(2), 1.)
    	    CALL HS_SET_INDICATOR(IND_ID, FLOAT(I))
    	    IF (HS_CHECK_TRIGGER(TRIGGER_ID) .NE. 0)
     &           PRINT *, ' Trigger set by HistoScope'
    	    CALL HS_UPDATE

	    IF ( MOD(I, 200) .EQ. 0)  THEN 
                 PRINT *, ' Reaching computation ...', I
    	         CALL HS_READ_CONTROL(CTRL_MERRS_ID, ERRVAL_M)
c
c	That Control tunes an added systematic error, presumably 
c	proportional to the "K indices" ( Just an Example !)
c
		 DO K = 1, 10000
    	          IF (ERRVAL_M .GT. 0) THEN  
		   ERRS2D(K) = SQRT( .01 + ((ERRVAL_M*K)/10000)**2)
		  ELSE
		   ERRS2D(K) = .1
		  END IF 
                  ERRS2D_M(K) = ERRS2D(K)
		 ENDDO
		 DO K = 1, 100
    	          IF (ERRVAL_M .GT. 0) THEN  
		   ERRS1D(K) = SQRT( .01 + ((ERRVAL_M*K)/10000)**2)
		  ELSE
		   ERRS1D(K) = .1
		  END IF 
                  ERRS1D_M(K) = ERRS1D(K)
		 ENDDO
c
c	In this trivial example, the errors are symmetric.
c
    	         CALL HS_SET_1D_ERRORS(HS1_ID, ERRS1D_M, ERRS1D_M)
    	         CALL HS_SET_2D_ERRORS(HS2_ID, ERRS2D_M, ERRS2D_M)
            ENDIF
    	    CALL HS_READ_CONTROL(CTRL_ID, CVAL)
    	    CALL HS_READ_CONTROL(CTRL_NPTS_ID, FVALPTS)
    	    NUM_PTS = INT(FVALPTS)
    	    DO WHILE (CVAL .LT. 0.) 
    	    	 IF (HS_CHECK_TRIGGER(TRIGGER_ID) .NE. 0)
     &               PRINT *, ' Trigger set by HistoScope'
    	    	 CALL HS_UPDATE
    	    	 CALL HS_READ_CONTROL(CTRL_ID, CVAL)
            ENDDO
	I = I + 1
	END DO
	ISTAT = HS_SAVE_FILE('Apit1.hs')
	CALL HS_COMPLETE_AND_WAIT
	STOP
	END


      REAL FUNCTION RNDOM()
      INTEGER A,M,Q,R,HI,LO,TEST
      DATA A, M, Q, R, ISEED /16807, 2147483647, 127773, 2836, 19283755/

      HI = ISEED/Q
      LO = MOD(ISEED,Q)
      TEST = A*LO - R*HI
      IF(TEST.GT.0)  THEN
        ISEED = TEST
      ELSE
        ISEED = TEST + M
      END IF
      RNDOM = FLOAT(ISEED)/M
      RETURN
      END
