	PROGRAM NTEST
C
C PROGRAM TO GENERATE RANDOM N-TUPLE AND HISTOGRAM DATA
C
	IMPLICIT NONE
	INCLUDE 'histoscope.inc'
	INTEGER I, J, K, N_VARIABLES, HS1_ID, HS2_ID, NTUPLE_ID, ISTAT  
	REAL VALUES(8)
	REAL RNDM
	CHARACTER*8 TAGS(8)
	COMMON/PAWC/H
	REAL*4 H(1 000 000)
	
	N_VARIABLES = 8
        TAGS(1) = 'X'
        TAGS(2) = 'Y'
        TAGS(3) = 'IDX'
        TAGS(4) = 'SQRT(X)'
        TAGS(5) = 'SQRT(Y)'
        TAGS(6) = 'LOG(X)'
        TAGS(7) = 'LOG(Y)'
        TAGS(8) = 'SIN(IDX)'
	PRINT *, ' Expect 1 error message: '
	CALL HS_HBOOK_SETUP('//PAWC')
	CALL HS_INITIALIZE('NtupleF')
	CALL HS_HISTOSCOPE(1)
 	NTUPLE_ID = HS_CREATE_NTUPLE(101, 'EXAMPLE NTUPLE', 'HS',
     &     N_VARIABLES, TAGS)
 	HS1_ID = HS_CREATE_1D_HIST(102, 'EXAMPLE 1D HIST', 'HS', 'Y',
     &     'TOTAL', 100, 4600., 5400.)
 	HS2_ID = HS_CREATE_2D_HIST(103, '2D HIST EXAMPLE', 'HS','X',
     &     'Y', 'TOTAL', 100, 100, 4600., 5400., 4600., 5400.)
	CALL HLIMIT(250 000)
	PRINT *, ' Expect 1 error message: '
	CALL HS_RESET_HBOOK_SETUP('//PAWC')
	CALL HS_HBOOK_SETUP('//PAWC')
    	CALL HS_UPDATE
        CALL HBOOKN(100, 'ANOTHER NTUPLE', N_VARIABLES, ' ', 1000, TAGS)
	CALL HS_HBOOK_SETUP('//PAWC')
    	CALL HS_UPDATE
    	CALL HMDIR('HISTOGRAMS', 'S')
        CALL HBOOK2(200,'2D HIST',100,4600.,5400., 100,4600.,
     &     5400.0, 0.)
        CALL HBOOK1(300,'1D HIST',100,4600.,5400.,0.0)
	PRINT *, ' HLDIR CALLED: '
	CALL HLDIR('//PAWC', 'T')
	CALL HS_RESET_HBOOK_SETUP('//PAWC')
    	CALL HS_UPDATE
	CALL HROPEN(1, 'PAWPAW', 'ntuplef.hst', '  ', 1024, ISTAT)
	PRINT *, 'ISTAT = ', ISTAT, ' HLDIR CALLED: '
	CALL HLDIR('//PAWPAW', 'T')
	CALL HCDIR('//PAWPAW', ' ')
	CALL HRIN(0, 0, 0)
	CALL HS_HBOOK_SETUP('//PAWPAW')
	CALL HS_RESET_HBOOK_SETUP('//PAWC')
    	CALL HS_UPDATE
C
C	    RANDOM DATA COMPUTATION - THIS COULD BE ANY CODE YOU WISH
C	
	DO I = 1, 10000
    	    DO J = 1, 2
    		VALUES(J) = 0
    		DO K = 1, 1000
    	    	    VALUES(J) = VALUES(J) + RNDM() * 10.
    		ENDDO
    	    ENDDO
    	    
    	    VALUES(3) = I
    	    VALUES(4) = SQRT(VALUES(1))
    	    VALUES(5) = SQRT(VALUES(2))
    	    VALUES(6) = LOG(VALUES(1))
    	    VALUES(7) = LOG(VALUES(2))
    	    VALUES(8) = SIN(VALUES(3))

    	    ISTAT = HS_FILL_NTUPLE(NTUPLE_ID, VALUES)
    	    CALL HS_FILL_1D_HIST(HS1_ID, VALUES(2), 1.)
    	    CALL HS_FILL_2D_HIST(HS2_ID, VALUES(1), VALUES(2), 1.)
    	    CALL HCDIR('//PAWC/HISTOGRAMS', ' ')
	    CALL HFILL(200, VALUES(1), VALUES(2), 1.)
	    CALL HFILL(300, VALUES(2), 0., 1.)
    	    CALL HCDIR('//PAWC', ' ')
	    CALL HFN(100, VALUES)
    	    CALL HS_UPDATE

	    IF ( MOD(I, 200) .EQ. 0)  THEN 
                 PRINT *, ' Reaching computation ...', I
            ENDIF
	END DO
	ISTAT = HS_SAVE_FILE('NTest.hs')
	CALL HS_KILL_HISTOSCOPE
	CALL HS_COMPLETE
	CALL HREND('PAWPAW')
	CALL HRPUT(0, 'NTest.hst ', 'TN')
	STOP
	END

      REAL FUNCTION RNDOM()
      INTEGER A,M,Q,R,HI,LO,TEST
      DATA A, M, Q, R, ISEED /16807, 2147483647, 127773, 2836, 19283755/

      HI = ISEED/Q
      LO = MOD(ISEED,Q)
      TEST = A*LO - R*HI
      IF(TEST.GT.0)  THEN
        ISEED = TEST
      ELSE
        ISEED = TEST + M
      END IF
      RNDOM = FLOAT(ISEED)/M
      RETURN
      END
	
