#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "histoscope.h"
/*
 *	NtupleExample.c - program to generate random n-tuple data
 */
#define TRUE 1
#define HLIM 250000
struct pawC { int h[HLIM]; } pawc_;
main()
{
    int n_variables = 8, ctrl_id1;
    float values[8], num_pts=10000., ov[3][3];
    float con_1 = 1., con_0 = 0., con_3400 = 3400., con_5400 = 5400., cval;
    int i, j, k, ntuple_id, hs1_id, hs2_id, ind_id, ctrl_id, hlim = HLIM;
    int hb_1d = 6000, hb_2d = 5000, hb_nt = 900, ic_100 = 100, ic_1000 = 1000;
    static char *names[8] = {"X", "Y", "index", "sqrt(X)", "sqrt(Y)", "log(X)",
       "log(Y)", "sin(index)"};
    static char hbNames[8][8] = {"X      ", "Y      ", "idx    ", "sqrt(X)",
	"sqrt(Y)", "log(X) ", "log(Y) ", "sin(idx)"};

    hs_initialize("NtupleC");
    hs_histoscope(TRUE);
    hs_histo_with_config(TRUE, "NtupleC.cfg");
    ntuple_id = hs_create_ntuple(101, "ExampleNtuple", "HS", n_variables, 
    		names);
    hs1_id = hs_create_1d_hist(102, "Example1dHist", "HS", "Y", "total", 100,
		3400., 5400.);
    hs2_id = hs_create_2d_hist(103, "2dHistExample", "HS", "X", "Y", "total",
		100, 100, 3400., 5400., 3400., 5400.);
    ctrl_id = hs_create_control(201, "Control: Pause if < 0",  "HS",  -500.,
    		500., 0.);
    ctrl_id1 = hs_create_control(202, "Control: Num of points", "HS", 0.,
    		10000., 10000.);
    ind_id = hs_create_indicator(104, "Indicator Example", "HS", 0., 10000.);
    hlimit_(&hlim);
    hbookn_(&hb_nt, "example_ntuple", &n_variables, " ", &ic_1000, hbNames, 14,
    		1, 8);
    hbook2_(&hb_2d, "2d hist example", &ic_100, &con_3400, &con_5400, &ic_100,
    		&con_3400, &con_5400, &con_0, 15);
    hbook1_(&hb_1d, "example 1d hist", &ic_100, &con_3400, &con_5400, &con_0,
    		15);
    printf(" HLDIR called:\n");
    hldir_("//PAWC", "T", 6, 1);
    hs_hbook_setup("//PAWC");
    
    hs_fill_2d_hist(hs2_id,    1.0, 6000.0, 1.);                /* -X +Y */
    hs_fill_2d_hist(hs2_id,    1.0, 5000.0, 2.);                /* -X    */
    hs_fill_2d_hist(hs2_id,    1.0,    1.0, 3.);                /* -X -Y */
    hs_fill_2d_hist(hs2_id, 5000.0, 6000.0, 4.);                /*    +Y */
    hs_fill_2d_hist(hs2_id, 5000.0,    1.0, 5.);                /*    -Y */
    hs_fill_2d_hist(hs2_id, 6000.0, 6000.0, 6.);                /* +X +Y */
    hs_fill_2d_hist(hs2_id, 6000.0, 5000.0, 7.);                /* +X    */
    hs_fill_2d_hist(hs2_id, 6000.0,    1.0, 8.);                /* +X -Y */
    
    for (i = 1; i <= num_pts; ++i) {
    
    	/* Random data computation - This could be any code you wish */
    	for (j = 0; j < 2; ++j) {
    	    values[j] = 0;
    	    for (k = 0; k < 1000; k++)
    	    	values[j] += fmod((float)random(), 10.);
    	}
    	values[2] = i;
    	values[3] = sqrt(values[0]);
    	values[4] = sqrt(values[1]);
    	values[5] = log(values[0]);
    	values[6] = log(values[1]);
    	values[7] = sin(values[2]);

    	hs_fill_ntuple(ntuple_id, values);
    	hs_fill_1d_hist(hs1_id, values[1], 1.);
    	hs_fill_2d_hist(hs2_id, values[0], values[1], 1.);
	hfill_(&hb_2d, &values[0], &values[1], &con_1);
	hfill_(&hb_1d, &values[1], &con_0, &con_1);
	hfn_(&hb_nt, values);
	hs_set_indicator(ind_id, (float)i);
    	hs_update();

    	/*  Print one period per n-tuple fill, to get  */
    	/*   visual feedback of program operation      */
    	printf(".");
    	fflush(stdout); 
    	hs_read_control(ctrl_id, &cval);
    	hs_read_control(ctrl_id1, &num_pts);
    	while (cval < 0) {
    	    hs_update();
    	    hs_read_control(ctrl_id, &cval);
    	}
    }

    hs_2d_hist_overflows(hs2_id, ov);
    for (i = 0; i < 3; ++i) {
        for (j = 0; j < 3; ++j) {
            printf("2d_overflow[%d][%d] = %f\n", i, j, ov[i][j]);
        }
    }
    
    hs_save_file("NtupleC.hs");
    hs_complete();
    hrput_(&con_0, "ntuplec.hst ", "TN", 11, 2);
}

	
