#include <math.h>
#include <stdio.h>
#include "histoscope.h"
/*
 *	NtupleExample.c - program to generate random n-tuple data
 */
#define TRUE 1
main()
{
    int n_variables = 8;
    float values[8];
    int i, j, k, ntuple_id;
    static char *names[8] = {      "X",      "Y",  "index",    "sqrt(X)",
    			     "sqrt(Y)", "log(X)", "log(Y)", "sin(index)"  };
        
    hs_initialize("NtupleExample");
    hs_histoscope(TRUE);
    ntuple_id = hs_create_ntuple(101, "example_ntuple", NULL, n_variables, names);
    
    for (i = 0; i < 10000; ++i) {
    
    	/* Random data computation - This could be any code you wish */
    	for (j = 0; j < 2; ++j) {
    	    values[j] = 0;
    	    for (k = 0; k < 1000; k++)
    	    	values[j] += fmod((float)random(), 10.);
    	}
    	values[2] = i;
    	values[3] = sqrt(values[0]);
    	values[4] = sqrt(values[1]);
    	values[5] = log(values[0]);
    	values[6] = log(values[1]);
    	values[7] = sin(values[2]);
    	
    	hs_fill_ntuple(ntuple_id, values);
    	hs_update();
    	
    	/*  Print one period per n-tuple fill, to get  */
    	/*   visual feedback of program operation      */
    	printf(".");
    	fflush(stdout); 
    }
    i = 101;
    hs_save_file_items("NtupleExample.hs", NULL, &i, 1); 
    hs_delete_category(NULL);
    hs_complete_and_wait();
}
