	PROGRAM NTUPLEFGROUP
C
C PROGRAM TO GENERATE RANDOM N-TUPLE AND HISTOGRAM DATA
C
	IMPLICIT NONE
	INCLUDE 'histoscope.inc'
	INTEGER I, J, K, N_VARIABLES, HS1_ID1, HS2_ID, NTUPLE_ID, ISTAT
	INTEGER CTRL_ID, IND_ID, NUM_PTS, CTRL_NPTS_ID, CTRL_MERRS_ID
	INTEGER TRIGGER_ID, GROUP_ID, GRP_IDS(12), HS1_ID2, HS1_ID3
	INTEGER HS1_ID4, HS1_ID5, ERR_ARRAY(12), NUM_IDS, TRIGGER1_ID
	INTEGER TRIGGER2_ID, GROUP2_ID, GROUP3_ID, GROUP4_ID, GROUP5_ID
	REAL VALUES(8), CVAL, FVALPTS, ERRVAL_M, TMP
	REAL ERRS1D(100), ERRS2D(10000), ERRS1D_M(100), ERRS2D_M(10000)
	REAL RNDOM
	INTEGER CHKTRG1, CHKTRG2
	CHARACTER*8 TAGS(8), TAGSC(5)
	INTEGER N_VARC, N_HB_CYCLE
	PARAMETER (N_VARC = 4, N_HB_CYCLE = 100)
	REAL VALUES_C(N_VARC)
	COMMON/PAWC/H
	REAL*4 H(1 000 000)
	
	N_VARIABLES = 8
	NUM_PTS = 10000
        TAGS(1) = 'X'
        TAGS(2) = 'Y'
        TAGS(3) = 'IDX'
        TAGS(4) = 'SQRT(X)'
        TAGS(5) = 'SQRT(Y)'
        TAGS(6) = 'LOG(X)'
        TAGS(7) = 'LOG(Y)'
        TAGS(8) = 'SIN(IDX)'
        
        TAGSC(1) = 'IEVT'
        TAGSC(2) = 'HBOOK_CYCLE'
        TAGSC(3) = 'X'
        TAGSC(4) = 'Y'
        
	DO I = 1, 10000
	    ERRS2D(I) = .1
	    ERRS2D_M(I) = 0.
	ENDDO
	DO I = 1, 100
	    ERRS1D_M(I) = 0.
	    ERRS1D(I) = 0.
	ENDDO
	DO I = 1, 11
	    ERR_ARRAY(I) = HS_NO_ERROR_BARS
	ENDDO
	CHKTRG1 = 1
	CHKTRG2 = 1
	CALL HS_INITIALIZE('NtupleFGroup')
	CALL HS_HISTOSCOPE(1)
 	NTUPLE_ID = HS_CREATE_NTUPLE(101, 'EXAMPLE NTUPLE', 'HS',
     &     N_VARIABLES, TAGS)
 	HS1_ID1 = HS_CREATE_1D_HIST(201, 'X-AMPLE 1D HIST', 'HS', 'X',
     &      'TOTAL', 100, 4600., 5400.)
 	HS1_ID2 = HS_CREATE_1D_HIST(202, 'Y-AMPLE 1D HIST', 'HS', 'Y',
     &      'TOTAL', 100, 4600., 5400.)
 	HS1_ID3 = HS_CREATE_1D_HIST(203, 'X+Y-AMPLE 1D HIST', 'HS',
     &      'X+Y', 'TOTAL', 100, 9200., 10800.)
 	HS1_ID4 = HS_CREATE_1D_HIST(204, 'X-Y-AMPLE 1D HIST', 'HS',
     &      'X-Y', 'TOTAL', 100, -800., 800.)
 	HS1_ID5 = HS_CREATE_1D_HIST(205, 'X*Y-AMPLE 1D HIST', 'HS',
     &      'X*Y', 'TOTAL', 100, 21160000., 29160000.)
 	HS2_ID = HS_CREATE_2D_HIST(301, '2D HIST EXAMPLE', 'HS','X','Y',
     &     'TOTAL', 100, 100, 4600., 5400., 4600., 5400.)
	CTRL_ID = HS_CREATE_CONTROL(401, 'CONTROL: PAUSE IF .LT. 0',
     &     'HS', -500., +500., 0.)
	CTRL_NPTS_ID = HS_CREATE_CONTROL(402, 'CONTROL: NUM OF PTS',
     &     'HS', 0., 10000., 10000.)
	CTRL_MERRS_ID = HS_CREATE_CONTROL(403,
     &      'CONTROL: ACCUM NONSYM NEG ERRS', 'HS', 0., 1., 0.)
	IND_ID = HS_CREATE_INDICATOR(501, 'INDICATOR EXAMPLE', 'HS', 0.,
     &      10000.)
	TRIGGER_ID = HS_CREATE_TRIGGER(601, 'TRIGGER EXAMPLE', 'HS')
	TRIGGER1_ID = HS_CREATE_TRIGGER(602, 'TRIGGER: RESET GROUP',
     &      'HS')
	TRIGGER2_ID = HS_CREATE_TRIGGER(603, 'TRIGGER: DELETE GROUP',
     &      'HS')
	GRP_IDS(1) = HS1_ID1
	GRP_IDS(2) = HS1_ID2
	GRP_IDS(3) = HS1_ID3
	GRP_IDS(4) = -1
	GRP_IDS(5) = HS1_ID4
	GRP_IDS(6) = HS1_ID5
	GRP_IDS(7) = HS2_ID
	GRP_IDS(8) = CTRL_ID
	GRP_IDS(9) = IND_ID
	GRP_IDS(10) = NTUPLE_ID
	GRP_IDS(11) = HS2_ID
	NUM_IDS = 11
	ERR_ARRAY(1) = HS_GAUSSIAN_ERROR_BARS
	ERR_ARRAY(3) = HS_DATA_ERROR_BARS
	ERR_ARRAY(5) = HS_GAUSSIAN_ERROR_BARS
	ERR_ARRAY(6) = HS_DATA_ERROR_BARS
	ERR_ARRAY(11) = HS_GAUSSIAN_ERROR_BARS
        PRINT *, ' Expect 1 error for illegal group item:'
	GROUP_ID = HS_CREATE_GROUP(701, 'GROUP 1 (Multi-plot)', 'HS',
     &      HS_MULTI_PLOT, NUM_IDS, GRP_IDS, ERR_ARRAY)
	GRP_IDS(4) = HS2_ID
	ERR_ARRAY(4) = HS_GAUSSIAN_ERROR_BARS
	GROUP2_ID = HS_CREATE_GROUP(702, 'HISTOGRAM GROUP 2 (Multi)',
     &      'HS', HS_MULTI_PLOT, 7, GRP_IDS, ERR_ARRAY)
	GROUP3_ID = HS_CREATE_GROUP(703, 'HISTOGRAM GROUP 3 (Overlay)',
     &      'HS', HS_OVERLAY_PLOT, 7, GRP_IDS, ERR_ARRAY)
	GROUP4_ID = HS_CREATE_GROUP(704, 'GROUP 4 (Individual)', 'HS',
     &      HS_INDIVIDUAL, NUM_IDS, GRP_IDS, ERR_ARRAY)
	CALL HLIMIT(250 000)
        CALL HBOOKN(900, 'EXAMPLE NTUPLE', N_VARIABLES, ' ', 1000, TAGS)
        CALL HBOOKN(910, 'EXAMPLE NTUPLE, Circular',
     &       N_VARC, ' ', N_HB_CYCLE, TAGSC)
        CALL HBOOK2(5000,'2D HIST EXAMPLE',100,4600.,5400., 100, 4600.,
     &     5400.0, 0.)
        CALL HBOOK1(6000,'EXAMPLE 1D HIST',100,4600.,5400.,0.0)
	PRINT *, ' HLDIR CALLED: '
	CALL HLDIR('//PAWC', 'T')
	CALL HS_HBOOK_SETUP('//PAWC')
C
C	    RANDOM DATA COMPUTATION - THIS COULD BE ANY CODE YOU WISH
C	
	I = 1
	DO WHILE (I .LE. NUM_PTS)
	    
    	    DO J = 1, 2
    		VALUES(J) = 0
    		DO K = 1, 1000
    	    	    VALUES(J) = VALUES(J) + RNDOM() * 10.
    		ENDDO
    	    ENDDO
    	    
    	    VALUES(3) = I
    	    VALUES(4) = SQRT(VALUES(1))
    	    VALUES(5) = SQRT(VALUES(2))
    	    VALUES(6) = LOG(VALUES(1))
    	    VALUES(7) = LOG(VALUES(2))
    	    VALUES(8) = SIN(VALUES(3))
    	    
    	    VALUES_C(1) = I
    	    VALUES_C(2) = I/N_HB_CYCLE
    	    VALUES_C(3) = VALUES(1)
    	    VALUES_C(4) = VALUES(2)

    	    ISTAT = HS_FILL_NTUPLE(NTUPLE_ID, VALUES)
    	    CALL HS_FILL_1D_HIST(HS1_ID1, VALUES(1), 1.)
    	    CALL HS_FILL_1D_HIST(HS1_ID2, VALUES(2), 1.)
    	    TMP = VALUES(1) + VALUES(2)
    	    CALL HS_FILL_1D_HIST(HS1_ID3, TMP, 1.)
    	    TMP = VALUES(1) - VALUES(2)
    	    CALL HS_FILL_1D_HIST(HS1_ID4, TMP, 1.)
    	    TMP = VALUES(1) * VALUES(2)
    	    CALL HS_FILL_1D_HIST(HS1_ID5, TMP, 1.)
    	    CALL HS_FILL_2D_HIST(HS2_ID, VALUES(1), VALUES(2), 1.)
    	    CALL HS_SET_INDICATOR(IND_ID, FLOAT(I))
	    CALL HFILL(5000, VALUES(1), VALUES(2), 1.)
	    CALL HFILL(6000, VALUES(2), 0., 1.)
	    CALL HFN(900, VALUES)
	    CALL HFNOV(910, VALUES_C)
    	    IF (HS_CHECK_TRIGGER(TRIGGER_ID) .NE. 0)
     &           PRINT *, ' Trigger set by HistoScope'
    	    IF (CHKTRG1 .EQ. 1 .AND. 
     &           HS_CHECK_TRIGGER(TRIGGER1_ID) .NE. 0) THEN
                 CALL HS_RESET(GROUP_ID)
                 PRINT *, ' Group Reset Trigger set by HistoScope'
                 PRINT *, ' ...Resetting all items in the group'
            ENDIF
    	    IF (CHKTRG1 .EQ. 1 .AND.  
     &           HS_CHECK_TRIGGER(TRIGGER2_ID) .NE. 0) THEN
                 PRINT *, ' Group Delete Trigger set by HistoScope'
                 PRINT *, ' ...Deleting group and associated triggers'
                 PRINT *, ' ...but not the histograms in the group'
                 CALL HS_DELETE(GROUP_ID)
                 CALL HS_DELETE(TRIGGER1_ID)
                 CALL HS_DELETE(TRIGGER2_ID)
                 CHKTRG1 = 0
                 CHKTRG2 = 0
            ENDIF
    	    CALL HS_UPDATE

	    IF ( MOD(I, 200) .EQ. 0)  THEN
                 PRINT *, ' Reaching computation ...', I
    	         CALL HS_SET_1D_ERRORS(HS1_ID1, ERRS1D, %VAL(0))
    	         CALL HS_SET_1D_ERRORS(HS1_ID3, ERRS1D, %VAL(0))
    	         CALL HS_SET_1D_ERRORS(HS1_ID5, ERRS1D, %VAL(0))
    	         CALL HS_SET_2D_ERRORS(HS2_ID, ERRS2D, %VAL(0))
    	         CALL HS_READ_CONTROL(CTRL_MERRS_ID, ERRVAL_M)
		 DO K = 1, 10000
		     ERRS2D(K) = ERRS2D(K) + .1
    	             IF (ERRVAL_M .GT. 0)  
     &                         ERRS2D_M(K) = ERRS2D_M(K) + ERRVAL_M
		 ENDDO
		 DO K = 1, 100
		     ERRS1D(K) = ERRS1D(K) + .1
    	             IF (ERRVAL_M .GT. 0)  
     &                         ERRS1D_M(K) = ERRS1D_M(K) + ERRVAL_M
		 ENDDO
    	         IF (ERRVAL_M .GT. 0) THEN 
    	             CALL HS_SET_1D_ERRORS(HS1_ID1, %VAL(0), ERRS1D_M)
    	             CALL HS_SET_2D_ERRORS(HS2_ID, %VAL(0), ERRS2D_M)
    	         ENDIF
            ENDIF
    	    CALL HS_READ_CONTROL(CTRL_ID, CVAL)
    	    CALL HS_READ_CONTROL(CTRL_NPTS_ID, FVALPTS)
    	    NUM_PTS = INT(FVALPTS)
    	    DO WHILE (CVAL .LT. 0.) 
    	    	 IF (HS_CHECK_TRIGGER(TRIGGER_ID) .NE. 0)
     &               PRINT *, ' Trigger set by HistoScope'
    	    	 CALL HS_UPDATE
    	    	 CALL HS_READ_CONTROL(CTRL_ID, CVAL)
            ENDDO
	I = I + 1
	END DO
	ISTAT = HS_SAVE_FILE('NtupleFGroup.hs')
	CALL HS_COMPLETE_AND_WAIT
	CALL HRPUT(0, 'ntuplefg.hst ', 'TN')
	STOP
	END


      REAL FUNCTION RNDOM()
      INTEGER A,M,Q,R,HI,LO,TEST
      DATA A, M, Q, R, ISEED /16807, 2147483647, 127773, 2836, 19283755/

      HI = ISEED/Q
      LO = MOD(ISEED,Q)
      TEST = A*LO - R*HI
      IF(TEST.GT.0)  THEN
        ISEED = TEST
      ELSE
        ISEED = TEST + M
      END IF
      RNDOM = FLOAT(ISEED)/M
      RETURN
      END
	
