$ !
$ ! VMS procedure to compile and link modules for Histoscope client libraries.
$ !
$ ON ERROR THEN EXIT
$ IF P1 .EQS. "" 
$ THEN 
$     COMPILE := CC
$     LNK := LINK
$     FTN := FORTRAN/F77
$     DEFINE HUTIL [-.HISTO_UTIL]
$ ENDIF
$ IF P1 .EQS. "DEBUG" 
$ THEN 
$     COMPILE := CC/DEBUG/NOOPTIMIZE
$     LNK := LINK/DEBUG
$     FTN := FORTRAN/F77/DEBUG/NOOPTIMIZE
$     DEFINE HUTIL [-.HISTO_UTIL.DBG]
$ ENDIF
$ IF COMPILE .EQS. "" 
$ THEN 
$     WRITE SYS$OUTPUT "Unrecognized parameter: ''P1'"
$     EXIT 
$ ENDIF
$ ! Define symbols for compilation/link
$ @[-.HISTO]COMSYM
$ !
$ SET VERIFY
$ IF P1 .EQS. "DEBUG" THEN $ COMPILE HistoClient.c  /OBJECT=HistoClientHS.obj -
	/DEFINE=COM_DEBUG
$ IF P1 .EQS. "" THEN $ COMPILE HistoClient.c  /OBJECT=HistoClientHS.obj
$ COMPILE fortranBinding.c /OBJECT=fortranHSBinding.obj
$ COMPILE cBinding.c /OBJECT=cHSBinding.obj
$ !
$ IF P1 .EQS. "DEBUG" THEN $ COMPILE HistoClient.c  /OBJECT=HistoClientHB.obj -
	/DEFINE=(COM_DEBUG,LINKED_WITH_HBOOK)
$ IF P1 .EQS. "" THEN $ COMPILE HistoClient.c  /OBJECT=HistoClientHB.obj -
	/DEFINE=LINKED_WITH_HBOOK
$ COMPILE fortranBinding.c -
	/OBJECT=fortranHBBinding.obj /DEFINE=LINKED_WITH_HBOOK
$ COMPILE cBinding.c -
	/OBJECT=cHBBinding.obj /DEFINE=LINKED_WITH_HBOOK
$ COMPILE fortApiBinding.c
$ COMPILE cApiBinding.c  
$ COMPILE HbookClient.c
$ COMPILE clientHBList.c
$ COMPILE clientXDRsocket.c
$ COMPILE HISTOAPIHISTS.c
$ COMPILE HISTOAPIITEMS.c
$ COMPILE HISTOAPINTS.c
$ COMPILE HISTOAPISTATH.c
$ COMPILE HISTOAPIFILES.c
$ COMPILE HISTOAPIARYTH.c
$ COMPILE [-.histo_util]hsFile.c/DEFINE=VMS_CLIENT
$ MACRO LIBHISTOSHR
$ ! Make shareable library for linking client with
$ LINK/SHAR=HISTO_SHR.EXE/MAP=HISTO_SHR.map/FULL/cross LIBHISTOSHR.OBJ, -
	CLIENTXDRSOCKET.OBJ, -
	HUTIL:LIBHISTOUTIL.OLB/INCLUDE=xdrHisto, []LIBHISTOHB/OPT
$ ! Rest of client library is a .OLB file
$ LIBR/CREATE/OBJECT libFHistoHB HistoClientHB.obj, fortranHBBinding.obj, -
	fortApiBinding.OBJ, HbookClient.obj, clientHBList.obj, -
	HISTOAPIHISTS.OBJ, HISTOAPIITEMS.OBJ, HISTOAPINTS.OBJ, -
	HISTOAPISTATH.OBJ, HISTOAPIFILES.OBJ , HISTOAPIARYTH.OBJ, HSFILE.OBJ, -
	HUTIL:publish.obj, utilHbook.obj, histoUtil.obj, -
	getHbookData.obj, scandir.obj, util:vmsutils.obj
$ LIBR/CREATE/OBJECT libFHisto HistoClientHS.obj, fortranHSBinding.obj, -
	fortApiBinding.OBJ, HISTOAPIHISTS.OBJ, HISTOAPIITEMS.OBJ, -
	HISTOAPISTATH.OBJ, HISTOAPIFILES.OBJ , HISTOAPIARYTH.OBJ, -
	HISTOAPINTS.OBJ, HSFILE.OBJ, HUTIL:publish.obj, scandir.obj, -
	histoUtil.obj, util:vmsutils.obj
$ LIBR/CREATE/OBJECT libCHistoHB HistoClientHB.obj, cHBBinding.obj, -
	HbookClient.obj, clientHBList.obj, cApiBinding.OBJ, HISTOAPIHISTS.OBJ, -
	HISTOAPIITEMS.OBJ, HISTOAPINTS.OBJ, HISTOAPISTATH.OBJ, -
	HISTOAPIFILES.OBJ , HISTOAPIARYTH.OBJ, HSFILE.OBJ, -
	HUTIL:publish.obj, utilHbook.obj, -
	histoUtil.obj, getHbookData.obj, scandir.obj, util:vmsutils.obj
$ LIBR/CREATE/OBJECT libCHisto HistoClientHS.obj, cHSBinding.obj, -
	cApiBinding.OBJ, HISTOAPIHISTS.OBJ, -
	HISTOAPIITEMS.OBJ, HISTOAPINTS.OBJ, HISTOAPISTATH.OBJ, -
	HISTOAPIFILES.OBJ , HISTOAPIARYTH.OBJ, HSFILE.OBJ, -
	HUTIL:publish.obj, scandir.obj, -
	histoUtil.obj, util:vmsutils.obj
$ ! Client programs
$ macro bcopy_bzero_VECTOR.MAR
$ FTN BCOPY.f
$ define BCOPY_SHR usr$scratch:[joyk.histo_api]BCOPY_bzero_SHR.exe
$ LINK/SHAR=BCOPY_bzero_SHR/MAP=BCOPY_bzero_SHR/FULL/CROSS  -
        BCOPY_bzero_VECTOR.OBJ, BCOPY.obj, SYS$INPUT/OPT 
NAME = BCOPY_SHR
IDENTIFICATION = "V1.0"
GSMATCH = LEQUAL,1,1
$ FTN APIT1.F
$ LNK/MAP/FULL/CROSS APIT1, libFHisto/lib, BCOPY_HISTO_OPT/opt
$ FTN/OBJECT=HBOOKEXAMPLEF.OBJ HBOOKEXAMPLEIBM.F
$ SET NOVERIFY
$ SETUP CERN
$ SET VERIFY
$ LNK/MAP/FULL/CROSS hbookExampleF, libFHistoHB/lib, -
	shr_options_file/opt,  CERNLIB_DIR:PACKLIB/lib, KERNLIB/lib
$ FTN/OBJECT=HSEXAMPLEF.OBJ HSEXAMPLEIBM.F
$ LNK/MAP/FULL/CROSS hsExampleF, libFHisto/lib, shr_options_file/opt
$ 
$ COMPILE hsExample.c /include=[]
$ LNK hsExample, libCHisto/lib, shr_options_file/opt
$ ! Decomitting hbookExample.c - not bothering to build descriptors for HBOOK
$ ! COMPILE hbookExample.c /include=[]
$ ! LNK hbookExample, libCHistoHB/lib, shr_options_file/opt, -
$ !	CERNLIB_DIR:PACKLIB/lib, KERNLIB/lib
$ FTN/OBJECT=ADVEXAMPLEF.OBJ ADVEXAMPLEIBM.F
$ LNK/MAP/FULL/CROSS advExampleF, libFHistoHB/lib, -
	shr_options_file/opt,  CERNLIB_DIR:PACKLIB/lib, KERNLIB/lib
$ FTN NTUPLEF.F
$ LNK/MAP/FULL/CROSS NTUPLEF, libFHistoHB/lib, -
	shr_options_file/opt,  CERNLIB_DIR:PACKLIB/lib, KERNLIB/lib
$ SET NOVERIFY
