/*******************************************************************************
*									       *
* fortAPIBindingLinux.c - FORTRAN Linux interface for Histo-Scope client API   *
*									       *
*		     This file is necessary because some Linux FORTRAN         *
*		     compilers put TWO underscores after routine names	       *
*									       *
* Copyright (c) 1997 Universities Research Association, Inc.		       *
* All rights reserved.							       *
* 									       *
* This material resulted from work developed under a Government Contract and   *
* is subject to the following license:  The Government retains a paid-up,      *
* nonexclusive, irrevocable worldwide license to reproduce, prepare derivative *
* works, perform publicly and display publicly by or for the Government,       *
* including the right to distribute to other Government contractors.  Neither  *
* the United States nor the United States Department of Energy, nor any of     *
* their employees, makes any warranty, express or implied, or assumes any      *
* legal liability or responsibility for the accuracy, completeness, or         *
* usefulness of any information, apparatus, product, or process disclosed, or  *
* represents that its use would not infringe privately owned rights.           *
*                                        				       *
* Fermilab Nirvana GUI Library						       *
* April 8, 1997								       *
*									       *
* Written by Joy Kyriakopulos						       *
*									       *
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "fortBind.h"

int hs_id__(int *uid, char *id_category, int length)
{
    return hs_id_(uid, id_category, length);
}

int hs_id_from_title__(char *id_title, char *id_category,
                                     int lengtht, int lengthc)
{
    return hs_id_from_title_(id_title, id_category, lengtht, lengthc);
}

int hs_list_items__(char *id_title, char *id_category, int *list, int *num,
                           int *matchFlg, int lengtht, int lengthc)
{
    return hs_list_items_(id_title, id_category, list, num, matchFlg, lengtht,
    			   lengthc);
}

int hs_uid__(int *id)
{

   return hs_uid_(id);
}

int hs_category__(int *id, char *id_category, int lengthc) 
{
    return hs_category_(id, id_category, lengthc);
}

int hs_title__(int *id, char *id_title, int lengtht) 
{
    return hs_title_(id, id_title, lengtht);
}

int hs_type__(int *id)
{
   return (int) (hs_type_(id));
}

int hs_read_file__(char *file, char *pref, int lengthf, int lengthp)
{
    return hs_read_file_(file, pref, lengthf, lengthp);
}


int hs_read_file_items__(char *file, char *pref, char *category, 
         int *uids, int *n_uids, int lengthf, int lengthp, int lengthc)
{
    return hs_read_file_items_(file, pref, category, uids, n_uids, lengthf,
    					lengthp, lengthc);
}


int hs_save_file_items__(char *file, char *category, int *uids, int *n_uids, 
         int lengthf, int lengthc )
{
    return hs_save_file_items_(file, category, uids, n_uids, lengthf, lengthc);
}

void hs_delete_category__(char *id_category, int lengthc)
{
    hs_delete_category_(id_category, lengthc);
}

void hs_change_uid__(int *id, int *newuid)
{
    hs_change_uid_(id, newuid);
}



void hs_change_category__(int *id, char *id_category, int lengthc)
{
    hs_change_category_(id, id_category, lengthc);
}

void hs_change_title__(int *id, char *id_title, int lengtht)
{
    hs_change_title_(id, id_title, lengtht);
}

int hs_num_items__(void)
{
    return hs_num_items_();
}

void hs_1d_hist_block_fill__(int *id, float *data, float *err, float *err_m)
{
   hs_1d_hist_block_fill_(id, data, err, err_m);
}

void hs_2d_hist_block_fill__(int *id, float *data, float *err, float *err_m)
{
   hs_2d_hist_block_fill_(id, data, err, err_m);
}

int hs_1d_hist_num_bins__(int *id)
{
    return hs_1d_hist_num_bins_(id);
}

void hs_2d_hist_num_bins__(int *id, int *num_x_bins, int *num_y_bins)
{
    hs_2d_hist_num_bins_(id, num_x_bins, num_y_bins);
}

void hs_1d_hist_range__(int *id, float *min, float *max)
{  
    hs_1d_hist_range_(id, min, max);
}

void hs_2d_hist_range__(int *id, float *x_min, float *x_max, float *y_min,
	float *y_max)
{
    hs_2d_hist_range_(id, x_min, x_max, y_min, y_max);
}

void hs_1d_hist_bin_contents__(int *id, float *data)
{
    hs_1d_hist_bin_contents_(id, data);
}

void hs_2d_hist_bin_contents__(int *id, float *data)
{
    hs_2d_hist_bin_contents_(id, data);
}

int hs_1d_hist_errors__(int *id, float *err, float *err_m)
{
    return hs_1d_hist_errors_(id, err, err_m);
}

int hs_2d_hist_errors__(int *id, float *err, float *err_m)
{
    return hs_2d_hist_errors_(id, err, err_m);
}

void hs_1d_hist_overflows__(int *id, float *underflow, float *overflow)
{
    hs_1d_hist_overflows_(id, underflow, overflow);
}

void hs_2d_hist_overflows__(int *id, float overflows[3][3])
{
    hs_2d_hist_overflows_(id, overflows);
}

void hs_1d_hist_set_overflows__(int *id, float *underflow, float *overflow)
{
    hs_1d_hist_set_overflows_(id, underflow, overflow);
}

void hs_2d_hist_set_overflows__(int *id, float overflows[3][3])
{
    hs_2d_hist_set_overflows_(id, overflows);
}

int hs_num_entries__(int *id)
{
    return hs_num_entries_(id);
}

float hs_1d_hist_x_value__(int *id, float *x)
{
   return hs_1d_hist_x_value_(id, x);
}

float hs_2d_hist_xy_value__(int *id, float *x, float *y)
{
   return hs_2d_hist_xy_value_(id, x, y);
}

float hs_1d_hist_bin_value__(int *id, int *bin_num)
{
   return hs_1d_hist_bin_value_(id, bin_num);
}

float hs_2d_hist_bin_value__(int *id, int *x_bin_num, int *y_bin_num)
{
   return hs_2d_hist_bin_value_(id, x_bin_num, y_bin_num);
}
   
void hs_1d_hist_minimum__(int *id, float *x, int *bin_num, float *value)
{
     hs_1d_hist_minimum_(id, x, bin_num, value);
}

void hs_2d_hist_minimum__(int *id, float *x, float *y, int *x_bin_num,
	int *y_bin_num, float *value)
{
     hs_2d_hist_minimum_(id, x, y, x_bin_num, y_bin_num, value);
}

void hs_1d_hist_maximum__(int *id, float *x, int *bin_num, float *value)
{
     hs_1d_hist_maximum_(id, x, bin_num, value);
}


void hs_2d_hist_maximum__(int *id, float *x, float *y, int *x_bin_num,
	int *y_bin_num, float *value)
{
     hs_2d_hist_maximum_(id, x, y, x_bin_num, y_bin_num, value);
}

void hs_1d_hist_stats__(int *id, float *mean, float *std_dev)
{
     hs_1d_hist_stats_(id, mean, std_dev);
}

void hs_2d_hist_stats__(int *id, float *x_mean, float *y_mean, float *x_std_dev,
	float *y_std_dev)
{
     hs_2d_hist_stats_(id, x_mean, y_mean, x_std_dev, y_std_dev);
}

float hs_hist_integral__(int *id)
{
     return hs_hist_integral_(id);
} 
   
void hs_hist_set_gauss_errors__(int *id)
{
     hs_hist_set_gauss_errors_(id);
}

int hs_sum_histograms__(int *uid, char *title, char *category,
                 int *id1, int *id2, float *const1, float *const2,
                 int lengtht, int lengthc)
{
    return hs_sum_histograms_(uid, title, category, id1, id2, const1, const2,
			      lengtht, lengthc);
}

int hs_multiply_histograms__(int *uid, char *title, char *category,
            int *id1, int *id2, float *consta, int lengtht, int lengthc)
{
    return hs_multiply_histograms_(uid, title, category, id1, id2, consta,
                        lengtht, lengthc);
}

int hs_1d_hist_derivative__(int *uid, char *title, char *category,
                 int *id, int lengtht, int lengthc)
{

    return hs_1d_hist_derivative_(uid, title, category, id, lengtht, lengthc);
}

int hs_divide_histograms__(int *uid, char *title, char *category,
            int *id1, int *id2, float *consta, int lengtht, int lengthc)
{
    return hs_divide_histograms_(uid, title, category, id1, id2, consta,
                        lengtht, lengthc);
}

int hs_num_variables__(int *id)
{
    return hs_num_variables_(id);
}

int hs_variable_name__(int *id, int *column, char *name, int lengthn)
{
    return hs_variable_name_(id, column, name, lengthn);
}

int hs_variable_index__(int *id, char *name, int lengthn)
{
    return hs_variable_index_(id, name, lengthn);
}

float hs_ntuple_value__(int *id, int *row, int *column)
{
     return hs_ntuple_value_(id, row, column);
}

void hs_ntuple_contents__(int *id, float *data)
{
     hs_ntuple_contents_(id, data);
}

void hs_row_contents__(int *id, int *row, float *data)
{
     hs_row_contents_(id, row, data);
}

void hs_column_contents__(int *id, int *column, float *data)
{
     hs_column_contents_(id, column, data);
     return;
}

int hs_merge_entries__(int *uid, char *title, char *category,
                          int *id1, int *id2, int lengtht, int lengthc)

{
    return hs_merge_entries_(uid, title, category, id1, id2, lengtht, lengthc);
}

void hs_sum_category__(char *cat_top1, char *cat_top2,
            char *prefixsum, int lengtht1, int lengtht2, int lengthp)
{
     hs_sum_category_(cat_top1, cat_top2, prefixsum, lengtht1, lengtht2, 
     	    lengthp);
}
 
void hs_sum_file__(char *file, char *cat_top,
            char *prefixsum, int lengthf, int lengtht, int lengthp)
{
     hs_sum_file_(file, cat_top, prefixsum, lengthf, lengtht, lengthp);
}

