#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <timers.h>
#include "histoscope.h"
static float getRand(int sign);
static float FlMax = 0, FlMin = 0;
/*
 *	clientTest.c
 */
int clientTest(void)
{
     char x_label[25], y_label[25], title[81], str[25], str1[25], z_label[25];
     char nTname[300][30];
     char *nTnames[300];
     char *cat;
     float min, max, minY, maxY;
     int i, j, k, l, item, type= 0, sign, nBins, nYBins, waitPr = 0;
     int uid, ntn = 0;
     float nTvals[300];
     struct timespec sleepTime = {1, 000000000};
     static char *pstr = "\n\
clientTest: Program to create an item, and\n\
            repetitively: fill it n times then sleep t seconds\n\
            Use ^C to end program.\n\
     valid item types: ntuple, 1dhist, 2dhist, indicator\n\
\n";
     
     for (i = 0; i < 300; ++i)
     	 nTnames[i] = &nTname[i][0];
     hs_initialize("clientTest");
     printf("%s", pstr);
     printf("sleep time in seconds? ");
     scanf("%d", &sleepTime.tv_sec);
     while (type == 0) {
	 printf ("\nitem type? ");
	 scanf("%s", str);
	 if (strcmp(str, "ntuple") == 0)
     	    type = 1;
	 if (strcmp(str, "1dhist") == 0)
     	    type = 2;
	 if (strcmp(str, "2dhist") == 0)
     	    type = 3;
	 if (strcmp(str, "indicator") == 0)
     	    type = 4;
     	 if (type == 0)
     	      printf("\nInvalid type, try again\n");
     }
     printf("Wait for prompt before first fill? ");
     scanf("%s", str);
     if ( (strcmp(str, "yes") == 0) || (strcmp(str, "y") == 0) ) {
         waitPr = 1;
     }
     printf("uid? ");
     scanf("%d", &uid);
     printf("title? ");
     scanf("%s", title);
     cat = malloc(513);
     printf("category string? ");
     scanf("%s", cat);
     if (strncmp(str1, "null", 4) == 0) {
     	 free(cat);
     	 cat = NULL;
     }
     while (FlMax <= 0) {
	 printf("Largest positive random fl pt number? ");
	 scanf("%f", &FlMax);
	 if (FlMax <= 0)
	     printf("\nNumber not positive, try again\n");
     }
     while (FlMin >= 0) {
	 printf("Smallest negative random fl pt number? ");
	 scanf("%f", &FlMin);
	 if (FlMin >= 0)
	     printf("\nNumber not negative, try again\n");
     }
     sign = 1;
     switch (type) {
     	 case 1:
     	     for (k = 0; k <= 0 || k > 300; ) {
     		 printf("number of variables? ");
     		 scanf("%d", &k);
     		 if (k <= 0 || k > 300)
     		 	printf("0 < k <= 300\n");
     	     }
     	     for (l = 0; l < k; ++l) {
     		 printf("variable %d name? ", l+1);
     		 scanf("%s", nTnames[l]);
     	     }
     	     printf("number of fills per %d seconds? ", sleepTime.tv_sec);
     	     scanf("%d", &i);
     	     item = hs_create_ntuple(uid, title, cat, k, nTnames);
     	     while (waitPr) {
     	         hs_update();
     	         printf("start filling now? ");
     	         scanf("%s", str);
		 if ( (strcmp(str, "yes") == 0) || (strcmp(str, "y") == 0) )
        	     waitPr = 0;
     	     }
     	     while (1) {
     	         for (j = 1; j <= i; ++j) {
     	             for (l = 0; l < k; ++l)
     	             	 nTvals[l] = getRand(sign);
     	             if (hs_fill_ntuple(item, nTvals) <= 0) {
     	             	printf("Error in filling ntuple. (n = %d)\n", ntn);
     	             	exit (0);
     	             }
     	             ++ntn;
     	         }
     	         nanosleep(&sleepTime, NULL);
     	         sign = -sign;
     	         hs_update();
     	     }
     	 case 2:
     	     printf("x label? ");
     	     scanf("%s", x_label);
     	     printf("y label? ");
     	     scanf("%s", y_label);
     	     printf("number of bins? ");
     	     scanf("%d", &nBins);
     	     printf("histogram MINimum? ");
     	     scanf("%f", &min);
     	     printf("histogram MAXimum? ");
     	     scanf("%f", &max);
     	     printf("number of fills per %d seconds? ", sleepTime.tv_sec);
     	     scanf("%d", &i);
     	     item = hs_create_1d_hist(uid, title, cat, x_label, y_label, nBins,
     		      min, max);
     	     while (waitPr) {
     	         hs_update();
     	         printf("start filling now? ");
     	         scanf("%s", str);
		 if ( (strcmp(str, "yes") == 0) || (strcmp(str, "y") == 0) )
        	     waitPr = 0;
	     }
     	     while (1) {
     	         for (j = 1; j <= i; ++j)
     	             hs_fill_1d_hist(item, getRand(sign), 1.);
     	         nanosleep(&sleepTime, NULL);
     	         sign = -sign;
     	         hs_update();
     	     }

     	 case 3:
     	     printf("x label? ");
     	     scanf("%s", x_label);
     	     printf("y label? ");
     	     scanf("%s", y_label);
     	     printf("z label? ");
     	     scanf("%s", z_label);
     	     printf("number of X bins? ");
     	     scanf("%d", &nBins);
     	     printf("number of Y bins? ");
     	     scanf("%d", &nYBins);
     	     printf("histogram X MINimum? ");
     	     scanf("%f", &min);
     	     printf("histogram X MAXimum? ");
     	     scanf("%f", &max);
     	     printf("histogram Y MINimum? ");
     	     scanf("%f", &minY);
     	     printf("histogram Y MAXimum? ");
     	     scanf("%f", &maxY);
     	     printf("number of fills per %d seconds? ", sleepTime.tv_sec);
     	     scanf("%d", &i);
     	     item = hs_create_2d_hist(uid, title, cat, x_label, y_label, z_label,
     		      nBins, nYBins, min, max, minY, maxY);
     	     while (waitPr) {
     	         hs_update();
     	         printf("start filling now? ");
     	         scanf("%s", str);
		 if ( (strcmp(str, "yes") == 0) || (strcmp(str, "y") == 0) )
        	     waitPr = 0;
     	     }
     	     while (1) {
     	         for (j = 1; j <= i; ++j) {
     	             hs_fill_2d_hist(item, getRand(sign), getRand(-sign), 1.);
     	             ++j;
     	             if (j <= i)
     	                hs_fill_2d_hist(item, getRand(sign), getRand(sign), 1.);
     	         }
     	         nanosleep(&sleepTime, NULL);
     	         sign = -sign;
     	         hs_update();
     	     }
     	 case 4:
     	     printf("indicator MINimum? ");
     	     scanf("%f", &min);
     	     printf("indicator MAXimum? ");
     	     scanf("%f", &max);
     	     item = hs_create_indicator(uid, title, cat, min, max);
     	     hs_update();
     	     while (waitPr) {
     	         hs_update();
     	         printf("start setting indicator? ");
     	         scanf("%s", str);
		 if ( (strcmp(str, "yes") == 0) || (strcmp(str, "y") == 0) )
        	     waitPr = 0;
     	     }
     	     while (1) {
     	         hs_set_indicator(item, getRand(sign));
     	         nanosleep(&sleepTime, NULL);
     	         sign = -sign;
     	         hs_update();
     	     }
     	 default:
     	     ;
     }
     return(0);
} 

static float getRand(int sign)
{
     float f, g, h;
     
     f = rand();
     if (sign < 0) {
     	 h = fmod(f, FlMin);
     	 g = -h;
     }
     else {
     	 h = fmod(f, FlMax);
     	 g = h;
     }
     /* printf("getRand: %f, f = %f, h = %f, sign = %d\n", g, f, h, sign); */
     return g; 
}
