#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "histoscope.h"
/*
 *	testHistoClient.c
 */
int testHistoClient(void)
 {
     char str[25], str1[25];
     char *nTnames[6];
     float f, g, h;
     int i, j, k, l, tmp, uid, scatter = 0;
     int id[100];
     static float nTvals[6] = {0., .1, .2, .3, .4, .5};
     static char *pstr = "\n\
action responses to done prompt:\n\
     y                 - for yes, I'm done\n\
     yes               - for yes, I'm done\n\
     ind<rest-of-name> - to create an indicator & then call hs_update()\n\
     ntu<rest-of-name> - to create an ntuple    |   |    |    |\n\
     hs1<rest-of-name> - to create a 1d histogram   |    |    |\n\
     hs2<rest-of-name> - to create a 2d histogram   |    |    |\n\
     complete          - to call hs_complete()  |   |    |    |\n\
     init              - to call hs_initialize()|   |    |    |\n\
     reset             - to call hs_reset() for an item  |    |\n\
     delete            - to call hs_delete() for an item |    |\n\
     savef             - to call hs_save_file() for items|    |\n\
     setind            - to call hs_set_indicator() |    |    |\n\
     fillnt            - to call hs_fill_ntuple()   |    |    |\n\
     fill1d            - to call hs_fill_1d_hist()  |    |    |\n\
     fill2d            - to call hs_fill_2d_hist()  |    |    |\n\
     scatter           - sets/clears random fill mode    |    |\n\
     list              - to get this list printed out again   |\n\
     anything else     - just calls hs_update()\n\n";
     
     hs_initialize("testing HistoClient");
     for (i = 0; i < 100; ++i)
     	id[i] = 0;
     printf("\ntestHistoClient running.  hs initialized.  Creating 4 items.\n");
     l = hs_create_indicator(3001, "indicatorTest", "category1", -100., 100.);
     id[l] = l;
     j = hs_create_1d_hist(3002, "1dtest", "category1", "x_label", "y_label",
     		 12, -1., 11.);
     id[j] = j;
     k = hs_create_2d_hist(3003, "2dtest", "category1", "x_label", "y_label", 
     		 "z-label", 12, 12, -1., 11., -1., 11.);
     id[k] = k;
     nTnames[0] = "var0";
     nTnames[1] = "var1";
     nTnames[2] = "var2";
     nTnames[3] = "var3";
     nTnames[4] = "var4";
     nTnames[5] = "var5";
     tmp = hs_create_ntuple(3004, "ntupleTest", "category1", 6, nTnames);
     id[tmp] = tmp;
     printf("Created items %d, %d, %d, and %d.", l, j, k, tmp);
     hs_set_indicator(l, 88.);
     for (i = -2; i <= 13; ++i) {
     	hs_fill_1d_hist(j, i, i*i);
     	hs_fill_2d_hist(k, i, i+1, i*i);
     }
     hs_fill_ntuple(tmp, nTvals);
     printf("\nExpect 5 warnings after this message:\n");
     hs_fill_1d_hist(k, i, i*i);	/* test 5 error conditions */
     hs_fill_2d_hist(j, i, i+1, i*i);
     hs_set_indicator(k, 88.);
     hs_set_indicator(l, 188.);
     hs_fill_ntuple(l, nTvals);
     printf("%s",pstr);	
     while (1) {
     	hs_update();
     	printf ("done? ");
     	scanf("%s", str);
     	if ( (strcmp(str, "yes") == 0) || (strcmp(str, "y") == 0) )
     	    break;
    	if (strncmp(str, "ind", 3) == 0) {
     	    printf("uid? ");
     	    scanf("%d", &uid);
     	    printf("category string? ");
     	    scanf("%s", str1);
     	    if (strncmp(str1, "null", 4) == 0)
     	    	tmp = hs_create_indicator(uid, str, NULL, -32768., 32767.);
     	    else if (strncmp(str1, "empty", 5) == 0)
     	    	tmp = hs_create_indicator(uid, str, "", -32768., 32767.);
     	    else tmp = hs_create_indicator(uid, str, str1, -32768., 32767.);
     	    id[tmp] = tmp;
     	    printf("indicator id just created = %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "complete", 8) == 0) {
     	    hs_complete();
     	    printf("hs_complete() called.\n");
     	    continue;
     	}
     	if (strncmp(str, "reset", 5) == 0) {
     	    printf("   id of item to reset? ");
     	    scanf("%d", &tmp);
     	    hs_reset(tmp);
     	    printf("hs_reset() called for item %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "init", 4) == 0) {
     	    hs_initialize("testing HistoClient -once more-");
     	    printf("hs_initialize() called.\n");
     	    continue;
     	}
     	if (strncmp(str, "delete", 6) == 0) {
     	    printf("   id of item to delete? ");
     	    scanf("%d", &tmp);
     	    hs_delete(tmp);
     	    printf("hs_delete() called for item %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "savef", 5) == 0) {
     	    printf("   filename? ");
     	    scanf("%s", str1);
     	    printf("hs_save_file() called.  %d items written.\n",
     	    	hs_save_file(str1));
     	    continue;
     	}
     	if (strncmp(str, "setind", 6) == 0) {
     	    printf("   id of indicator to set? ");
     	    scanf("%d", &tmp);
     	    printf("   indicator value? ");
     	    scanf("%f", &f);
     	    hs_set_indicator(tmp, f);
     	    printf("hs_set_indicator() called for item %d.\n", tmp);
     	}
     	if (strncmp(str, "ntu", 3) == 0) {
     	    printf("uid? ");
     	    scanf("%d", &uid);
     	    printf("category string? ");
     	    scanf("%s", str1);
     	    if (strncmp(str1, "null", 4) == 0)
     	    	tmp = hs_create_ntuple(uid, str, NULL, 6, nTnames);
     	    else if (strncmp(str1, "empty", 5) == 0)
     	    	tmp = hs_create_ntuple(uid, str, "", 6, nTnames);
     	    else tmp = hs_create_ntuple(uid, str, str1, 6, nTnames);
     	    id[tmp] = tmp;
     	    printf("ntuple id just created = %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "hs1", 3) == 0) {
     	    printf("uid? ");
     	    scanf("%d", &uid);
     	    printf("category string? ");
     	    scanf("%s", str1);
     	    if (strncmp(str1, "null", 4) == 0)
     	    	tmp = hs_create_1d_hist(uid, str, NULL, "x_label", "y_label", 
     		      20., -100., 100.);
     	    else if (strncmp(str1, "empty", 5) == 0)
     	    	tmp = hs_create_1d_hist(uid, str, "", "x_label", "y_label", 
     		      20., -100., 100.);
     	    else tmp = hs_create_1d_hist(uid, str, str1, "x_label", "y_label", 
     		      20., -100., 100.);
     	    id[tmp] = tmp;
     	    printf("1d histogram id just created = %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "hs2", 3) == 0) {
     	    printf("uid? ");
     	    scanf("%d", &uid);
     	    printf("category string? ");
     	    scanf("%s", str1);
     	    if (strncmp(str1, "null", 4) == 0)
     	    	tmp = hs_create_2d_hist(uid, str, NULL, "x_label", "y_label",
     	    	      "z_label", 20., 10., -100., 100., -50., 50.);
     	    else if (strncmp(str1, "empty", 5) == 0)
     	    	tmp = hs_create_2d_hist(uid, str, "", "x_label", "y_label",
     	    	      "z_label", 20., 10., -100., 100., -50., 50.);
     	    else tmp = hs_create_2d_hist(uid, str, str1, "x_label", "y_label",
     	    	      "z_label", 20., 10., -100., 100., -50., 50.);
     	    id[tmp] = tmp;
     	    printf("2d histogram id just created = %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "fillnt", 6) == 0) {
     	    printf("id? ");
     	    scanf("%d", &tmp);
	    if (scatter) {
     	    	printf("  # fills? ");
     		scanf("%d", &l);
		for (i = 0; i <= l; ++i) {
	    	    for (k = 0; k < 6; k++) {
			j = rand();
			nTvals[k] = -(j & 0x10f0) + (j & 0xf0f);
		    }
	    	hs_fill_ntuple(tmp, nTvals);
	    	}
	    }
	    else {
		for (k = 0; k < 6; k++) {
		    printf("   value %d? ", k);
	    	    scanf("%f", &nTvals[k]);
		}
		hs_fill_ntuple(tmp, nTvals);
	    }
	    printf("hs_fill_ntuple called for id %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "fill1d", 6) == 0) {
     	    printf("  id? ");
     	    scanf("%d", &tmp);
     	    if (scatter) {
     	    	printf("  # fills? ");
     		scanf("%d", &l);
		for (i = 0; i <= l; ++i) {
		    j = rand();
		    h = -(j & 0x10f0) + (j & 0xf0f);
		    hs_fill_1d_hist(tmp, h, (float)abs(j));
		}
	    }
     	    else {
     		printf("  x_axis value? ");
     		scanf("%f", &h);
     		printf("  weight value? ");
     		scanf("%f", &f);
		hs_fill_1d_hist(tmp, h, f);
		printf("hs_fill_1d_hist called for id %d.\n", tmp);
	    }
	    printf("hs_fill_1d_hist called for id %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "fill2d", 6) == 0) {
     	    printf("  id? ");
     	    scanf("%d", &tmp);
     	    if (scatter) {
     	    	printf("  # fills? ");
     		scanf("%d", &l);
		for (i = 0; i <= l; ++i) {
		    j = rand();
		    h = -(j & 0x10f0) + (j & 0xf0f);
		    k = rand();
		    g = -(k & 0x10f0) + (k & 0xf0f);
		    hs_fill_2d_hist(tmp, h, g, (float)abs(j));
		}
	    }
     	    else {
     		printf("  x_axis value? ");
     		scanf("%f", &h);
     		printf("  y_axis value? ");
     		scanf("%f", &g);
     		printf("  weight value? ");
     		scanf("%f", &f);
		hs_fill_2d_hist(tmp, h, g, f);
	    }
	    printf("hs_fill_2d_hist called for id %d.\n", tmp);
     	    continue;
     	}
     	if (strncmp(str, "scatter", 6) == 0) {
     	    scatter = !scatter;	
     	    continue;
     	}
     	if (strncmp(str, "list", 4) == 0) {
     	    printf("%s", pstr);	
     	    continue;
     	}
     }
     return(0);
 }
