#include <unixio.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "scandir.h"

static int mySelRoutine(char *filename);
static void callScandir(char *fnString);

static int IncludeIt = 1;		/* yes, include file */
static int AskToInclude = 0;		/* no, don't ask     */

int main()
{
    char dirSpec[15], incl[15];

    printf("\nProgram to test scandir.c\n\nLooking for files in TMP:HISTO*.\n");
    callScandir("TMP:HISTO*.");
    printf("\nLooking for default scandir case.\n");
    callScandir("");
    while (1) {
	printf("\nDirectory or wildcard specification to test? ");
	scanf("%s", &dirSpec);
	printf("\nPrompt to test if filename received is included? ");
	scanf("%s", &incl);
	if (incl[0] == 'y' || incl[0] == 'Y')
	    AskToInclude = 1;
	else
	    AskToInclude = 0;
	callScandir(dirSpec);
    }
}

static void callScandir(char *fnString)
{
    int i, numFound;
    char **namelist;
    char useSelRtn[15];

    if (!AskToInclude) {
	printf("\nCall scandir with null selection function? ");
	scanf("%s", &useSelRtn);
	if (useSelRtn[0] == 'y' || useSelRtn[0] == 'Y')
	    numFound = scandir(fnString, &namelist, 0, 0);
	else
	    numFound = scandir(fnString, &namelist, mySelRoutine, 0);
    }

    printf("\nNumber of files found in %s = %d\n", fnString, numFound);
    for (i = 0; i < numFound; ++i)
	printf("    %s\n", namelist[i]);
}

static int mySelRoutine(char *filename)
{
   char incl[15];

    printf("  in mySelRoutine, filename = %s\n", filename);
    if (AskToInclude) {
	printf("\nInclude this filename? ");
	scanf("%s", &incl);
	if (incl[0] == 'y' || incl[0] == 'Y')
	    return 1;
	else
	    return 0;
    }
    return 1;
}
