#ifdef VMS
#include <unixio.h>
#endif /*VMS*/
#include <stdio.h>
#include <string.h>
#include <errno.h>

#ifdef linux
#include <dirent.h>
static int mySelRoutine(struct dirent *filename);
#else
#include "scandir.h"
static int mySelRoutine(char *filename);
#endif /*linux*/

static void callScandir(char *fnString, int useSelRtn);

static int AskToInclude = 0;		/* no, don't ask     */

int main()
{
    char dirSpec[255], incl[255], useSelRtn[255];
    int selRtn = 1;

#ifdef VMS
    printf("\nProgram to test scandir.c\n\nLooking for files in TMP:HISTO*.\n");
    callScandir("TMP:HISTO*.");
    printf("\nLooking for default scandir case.\n");
    callScandir("");
#else
    printf("\nProgram to test scandir.c\n\nLooking for files in /tmp\n");
    callScandir("/tmp", 0);
    printf("\nLooking for files in ./\n");
    callScandir("./", 1);
#endif /*VMS*/
    while (1) {
#ifdef VMS
	printf("\nDirectory or wildcard specification to scan? ");
#else
	printf("\nDirectory to scan? ");
#endif /*VMS*/
	scanf("%s", &dirSpec);
	printf("\nCall scandir with a selection function? ");
	scanf("%s", &useSelRtn);
	selRtn = (useSelRtn[0] == 'y' || useSelRtn[0] == 'Y');
	if (selRtn != 0) {
	    printf("\nPrompt to test if filename should be included? ");
	    scanf("%s", &incl);
	    AskToInclude = (incl[0] == 'y' || incl[0] == 'Y');
	}
	callScandir(dirSpec, selRtn);
    }
}

static void callScandir(char *fnString, int useSelRtn)
{
    int i, numFound;
#ifdef linux
    struct dirent **namelist = NULL;
#else
    char **namelist;
#endif /*linux*/

    if (useSelRtn)
	numFound = scandir(fnString, &namelist, mySelRoutine, 0);
    else
	numFound = scandir(fnString, &namelist, 0, 0);

    printf("\nNumber of files found in %s = %d\n", fnString, numFound);
    for (i = 0; i < numFound; ++i)
#ifdef linux
	printf("    %s\n", namelist[i]->d_name);
#else
	printf("    %s\n", namelist[i]);
#endif /*linux*/
    if (numFound > 0 && namelist != NULL)
    	free(namelist);
}

#ifdef linux
static int mySelRoutine(struct dirent *filename)
#else
static int mySelRoutine(char *filename)
#endif /*linux*/
{
   char incl[15];

#ifdef linux
    printf("  in mySelRoutine, filename = %s\n", filename->d_name);
#else
    printf("  in mySelRoutine, filename = %s\n", filename);
#endif /*linux*/
    if (AskToInclude) {
	printf("\nInclude this filename? ");
	scanf("%s", &incl);
	if (incl[0] == 'y' || incl[0] == 'Y') {
#ifdef linux
	    printf("    errno = %d\n",errno);
	    kill(12345, 0);
	    printf("    errno = %d\n",errno);
#endif /*linux*/
	    return 1;
	} else {
#ifdef linux
	    printf("    errno = %d\n",errno);
	    errno = 0;
#endif /*linux*/
	    return 0;
	}
    }
    return 1;
}
