c
c UtilHbook.f -- Utilities needed to support ReadHbookList, and similar 
c routines.   
c			   
c Copyright (c) 1991 Universities Research Association, Inc.       
c All rights reserved.				       
c 		
c This material resulted from work developed under a Government Contract and 
c is subject to the following license:  The Government retains a paid-up,
c nonexclusive, irrevocable worldwide license to reproduce, prepare derivative
c works, perform publicly and display publicly by or for the Government,
c including the right to distribute to other Government contractors.  Neither
c the United States nor the United States Department of Energy, nor any of
c their employees, makes any warrenty, express or implied, or assumes any       
c legal liability or responsibility for the accuracy, completeness, or          
c usefulness of any information, apparatus, product, or process disclosed, or 
c represents that its use would not infringe privately owned rights. 
c                
c Fermilab Nirvana GUI Library	
c April  22, 1992
c July 1994 : upgrade the mkhbooklist routine to handle directories. 
c
c Written by Paul Lebrun                                                   
c
	SUBROUTINE InitHbook
c
c	This routine initializes the HBOOK COMMON block, It must be called
c	prior to ReadHbookList, or other any routines atempting to get 
c	Data from the HBOOK system. If called again, all previous structure
c	storedin that COMMON will be lost.
c
C	
	INTEGER SPACE_HBOOK
        PARAMETER (SPACE_HBOOK = 2 000 000)
        INTEGER IH(SPACE_HBOOK)
        COMMON /PAWC/IH
        
        CALL HLIMIT(SPACE_HBOOK)
        RETURN
        END


	INTEGER FUNCTION OPENHBOOKFILE(FILENAME, LREC) 

c This routine Opens the RZ File, Access it through a call to HRFILE, 
c write to an ASCII file a listing of all HBOOK/RZ directories and 
c their content.  This file is then read in sequentially, 
c for each histogram or N-tuple found, a new entry to the histo 
c structure is created. 
c
c	Arguments : 
c
c	FILENAME : Null terminated character string, pointing to an existing 
c		   HBOOK file.
c	LREC :	   Record length
c	
	IMPLICIT NONE
	CHARACTER*(*) FILENAME
	INTEGER ISTAT, LC, LREC
c
c	Attempt to open  the file
c
	LC = LEN(FILENAME)
	CALL HROPEN(45, 'Top ', FILENAME(1:LC), ' P', LREC, ISTAT)
	IF (ISTAT .NE. 0) 
     6     PRINT *, ' From ReadHbookList, Failing to open Hbook file '
 	OPENHBOOKFILE = ISTAT
 	RETURN
 	END
 	
 		
	SUBROUTINE CLOSEHBOOKFILE 

c This routine closes the RZ File, opened by OPENHBOOKFILE. 
c
c	
	IMPLICIT NONE
        CALL HREND('Top')
        CLOSE(UNIT = 45)
 	RETURN
 	END
 	
 	
	SUBROUTINE MKHBOOKLIST(FILENAME, DIRNAME)
C
	CHARACTER*60 FILENAME, NAME1
	CHARACTER*(*) DIRNAME
	INTEGER HBUNIT, LLD
	COMMON /HCUNIT/ LOUT
C
	LLD = LEN(DIRNAME)
	OPEN (Unit = 46, FILE=FILENAME, 
     &        STATUS = 'NEW', FORM='FORMATTED')
	HBUNIT = LOUT
	CALL HOUTPU(46)
	IF (DIRNAME(1:2) .EQ. '//') THEN 
	  CALL HLDIR(DIRNAME(1:LLD),'T')
	ELSE 
	  NAME1(1:2) = '//'
	  NAME1(3:LLD+2) = DIRNAME(1:LLD)
	  CALL HLDIR(NAME1(1:LLD+2),'T')
	END IF
	LOUT = HBUNIT
	CLOSE(46)
	
	RETURN
	END
	
