#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include "vxscandir.h"

#define MAX_NUM_FILES 100

int scandir(char *dirname, char **namelist[], int (*select)(char *dir),  
	void *compar)
{
    DIR *dp;
    struct dirent *dirp;
    int numFilesFound = 0;
    char **nameList = 0;
    
    if ( (dp = opendir(dirname)) == NULL )  {
    	fprintf(stderr, "hs_initialize: Cannot open directory %s\n", dirname);
    	return numFilesFound;
    }
    *namelist = 0;
    nameList = malloc(sizeof(char *) * MAX_NUM_FILES);
    if (nameList == NULL)  {
    	fprintf(stderr, "hs_initialize: Cannot do malloc (in vxscandir)\n");
    	return numFilesFound;
    }
    while ( (dirp = readdir(dp)) != NULL )  {
    	if ( select == NULL || (*select)(dirp->d_name) ) {
	    nameList[numFilesFound] = malloc(strlen(dirp->d_name)+1);
	    strcpy(nameList[numFilesFound], dirp->d_name);
	    ++numFilesFound;
    	    if (numFilesFound >= MAX_NUM_FILES) {
		break;
	    }
	}
    }
    if (numFilesFound > 0)
	*namelist = nameList;
    else
    	free(nameList);
    closedir(dp);
    return numFilesFound;
}
