#include <stdio.h>
#include <X11/Intrinsic.h> 
#include <Xm/Xm.h>
#include "H1D.h"

main(argc, argv)
  int   argc;
  char *argv[];
{
    Widget toplevel, h1D;
    int i;
    float bins[40], upErr[40], lowErr[40];

    for (i=0;i<40;i++) {
        bins[i] = (float) (i);
        if ( i > 20 ) bins[i] = 40.0 - bins[i];
        upErr[i] = bins[i]/2;
        lowErr[i] = 0-bins[i]*2;    /* note: normally not negative, this is
        			       just to make sure widget can handle it */
    }

     /*
     * Initialize the Intrinsics.
     */   
    toplevel = XtInitialize(argv[0], "H1DTest", NULL, 
                            0, &argc, argv);
    /*
     * Create a histogram widget and add a select callback.
     */
    h1D = XtVaCreateManagedWidget("h1D", h1DWidgetClass, toplevel,
        XmNxAxisLabel, XmStringCreateSimple("This is the X axis label"),
    	XmNyAxisLabel, XmStringCreateSimple("This is the Y axis label"),
    	XmNlogScaling, True, 0);
    H1DSetContents(h1D, 0., 10., 40., bins, upErr, lowErr, H1D_RESCALE);
    XtRealizeWidget(toplevel);
    XtMainLoop();
}
