#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <X11/Intrinsic.h> 
#include <Xm/Xm.h>
#include "Scat.h"

static void printCB(Widget w, caddr_t client_data, caddr_t call_data);
static void zoomInCB(Widget w, caddr_t client_data, caddr_t call_data);
static void zoomOutCB(Widget w, caddr_t client_data, caddr_t call_data);

main(argc, argv)
  int   argc;
  char *argv[];
{
    Widget toplevel, scat;
    int i, rnd;
    ScatPoint *point, *points;
    
    /*
     * Initialize the Intrinsics.
     */   
    toplevel = XtInitialize(argv[0], "ScatTest", NULL, 0, &argc, argv);
    /*
     * Create a scat widget and add a select callback.
     */
    /* scat = XtCreateManagedWidget("scat", scatWidgetClass, 
                        	 toplevel, NULL, 0); */
    scat = XtVaCreateManagedWidget("scat", scatWidgetClass, toplevel,
    	XmNxAxisLabel, XmStringCreateLtoR("This is the X axis label",
    		XmSTRING_DEFAULT_CHARSET),
    	XmNyAxisLabel, XmStringCreateLtoR("This is the Y axis label",
    		XmSTRING_DEFAULT_CHARSET),
    	XmNdarkerPoints, True,
    	XmNxLogScaling, True,
    	XmNyLogScaling, True, NULL);
    XtAddCallback(scat, XmNbtn2Callback,
                  (XtCallbackProc) zoomInCB, NULL);
    XtAddCallback(scat, XmNbtn3Callback,
                  (XtCallbackProc) zoomOutCB, NULL);
    
    points = (ScatPoint *)XtMalloc(sizeof(ScatPoint) * 1000);
    srand(1);
    for (point = points, i=0; i<1000; i++, point++) {
    	rnd = rand();
    	if ((rnd & 64) == 0)
    	    point->y = pow(10., (double)(rnd & 29));
    	else
    	    point->y = pow(10., -(double)(rnd & 29));
    	rnd = rand();
    	if ((rnd & 64) == 0)
    	    point->x = pow(10., (double)(rnd & 29));
    	else
    	    point->x = pow(10., -(double)(rnd & 29));
    	point->pixel = BlackPixel(XtDisplay(scat),0);
    }
    ScatSetContents(scat, points, 1000, SCAT_RESCALE);
    XtVaSetValues(scat, XmNxLogScaling, True, XmNyLogScaling, True, 0);
    XtRealizeWidget(toplevel);
    XtMainLoop();
}

static void printCB(Widget w, caddr_t client_data, caddr_t call_data)
{
    remove("scat.ps");
    ScatPrintContents(w, "scat.ps");
}

static void zoomInCB(Widget w, caddr_t client_data, caddr_t call_data)
{
    ScatZoomIn(w);
}

static void zoomOutCB(Widget w, caddr_t client_data, caddr_t call_data)
{
    ScatZoomOut(w);
}

