static char SCCSID[] = "@(#)testGetfiles.c	1.9	12/7/95";
#include <stdio.h>
#ifdef VMS
#include "VMSparam.h"
#else
#include <sys/param.h>
#endif /*VMS*/
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include "DialogF.h"
#include "getfiles.h"

static void btnECB(Widget w, caddr_t client_data, caddr_t call_data);
static void btnNCB(Widget w, caddr_t client_data, caddr_t call_data);
static void dirCB(Widget w, caddr_t client_data, caddr_t call_data);
static void patCB(Widget w, caddr_t client_data, caddr_t call_data);

main(int argc, char *argv[])
{
    Widget      toplevel, button, rowCol;
    Arg         args[10];
    int         n;
    
#if XtVersion >= 11005
    toplevel = XtInitialize(argv[0], "Hi!", NULL, 0, &argc, argv);
#else
    toplevel = XtInitialize(argv[0], "Hi!", NULL, 0, (Cardinal *)&argc, argv);
#endif
    n = 0;
    rowCol = XmCreateRowColumn(toplevel, "", 0, NULL);
    XtManageChild(rowCol);
    button = XmCreatePushButton(rowCol, "Get Existing File", args, n);
    XtAddCallback (button, XmNactivateCallback, (XtCallbackProc)btnECB, NULL);
    XtManageChild(button);
    button = XmCreatePushButton(rowCol, "Get New File", args, n);
    XtAddCallback (button, XmNactivateCallback, (XtCallbackProc)btnNCB, NULL);
    XtManageChild(button);
    button = XmCreatePushButton(rowCol, "Set Default Directory", args, n);
    XtAddCallback (button, XmNactivateCallback, (XtCallbackProc)dirCB, NULL);
    XtManageChild(button);
    button = XmCreatePushButton(rowCol, "Set Default Pattern", args, n);
    XtAddCallback (button, XmNactivateCallback, (XtCallbackProc)patCB, NULL);
    XtManageChild(button);
    XtRealizeWidget(toplevel);
    XtMainLoop();
}

static void btnECB(Widget w, caddr_t client_data, caddr_t call_data)
{
    char filename[MAXPATHLEN], *defaultDir, *defaultPattern;
    
    if (GetExistingFilename(w, "Prompt String:", filename) != GFN_OK)
    	return;
    printf("filename: %s\n", filename);
    defaultDir = GetFileDialogDefaultDirectory();
    defaultPattern = GetFileDialogDefaultPattern();
    printf("defaultDir %s, defaultPattern %s\n", defaultDir, defaultPattern);
    XtFree(defaultDir);
    XtFree(defaultPattern);
}
static void btnNCB(Widget w, caddr_t client_data, caddr_t call_data)
{
    char filename[MAXPATHLEN], *defaultDir, *defaultPattern;
    
    if (GetNewFilename(w, "Prompt String:", filename) != GFN_OK)
    	return;
    printf("filename: %s\n", filename);
    defaultDir = GetFileDialogDefaultDirectory();
    defaultPattern = GetFileDialogDefaultPattern();
    printf("defaultDir %s, defaultPattern %s\n", defaultDir, defaultPattern);
    XtFree(defaultDir);
    XtFree(defaultPattern);
}

static void dirCB(Widget w, caddr_t client_data, caddr_t call_data)
{
    int resp;
    char defaultDir[DF_MAX_PROMPT_LENGTH];
    
    defaultDir[0] = '\0';
    resp = DialogF(DF_PROMPT, w, 2, "Enter Default Directory",  defaultDir,
    	    "OK", "Cancel");
    if (resp == 2)
    	return;
    SetFileDialogDefaultDirectory(defaultDir);
}

static void patCB(Widget w, caddr_t client_data, caddr_t call_data)
{
    int resp;
    char defaultPat[DF_MAX_PROMPT_LENGTH];
    
    defaultPat[0] = '\0';
    resp = DialogF(DF_PROMPT, w, 2, "Enter Default Pattern",  defaultPat,
    	    "OK", "Cancel");
    if (resp == 2)
    	return;
    SetFileDialogDefaultPattern(defaultPat);
}
