static char SCCSID[] = "@(#)testPrint.c	1.8	9/16/94";
/* testPrint.c -- test print dialog routines */
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include "printUtils.h"

static void printCB(Widget w, caddr_t client_data, caddr_t call_data);

main(int argc, char *argv[])
{
    Widget      toplevel, button;
    Arg         args[10];
    int         n;
    FILE *fp;

    /* create a test file */
#ifdef VMS
    fp = fopen("testfile.txt","a");
#else
    fp = fopen("testfile","a");
#endif
    if (fp == NULL) {
#ifdef VMS
    	perror("couldn't create testfile.txt");
#else
    	perror("couldn't create testfile");
#endif
    	exit(1);
    }
    fprintf(fp, "Test...\n");
    fclose(fp);
    
#if XtVersion >= 11005
    toplevel = XtInitialize("testPrint", "TestPrint", NULL, 0, &argc, argv);
#else
    toplevel = XtInitialize("testPrint", "TestPrint", NULL, 0, 
    		(Cardinal *)&argc, argv);
#endif
    
    LoadPrintPreferences(XtDatabase(XtDisplay(toplevel)),
    	    "testPrint", "TestPrint", True);
	
    n = 0;
    button = XmCreatePushButton(toplevel, "Print Test File", args, n);
    XtAddCallback (button, XmNactivateCallback, (XtCallbackProc)printCB, NULL);
    XtManageChild(button);
    XtRealizeWidget(toplevel);
    XtMainLoop();
}

static void printCB(Widget w, caddr_t client_data, caddr_t call_data)
{
#ifdef VMS
    PrintFile(w, "testfile.txt", "from testPrint", 0);
    PrintFile(w, "testfile.txt", "from testPrint", 1);
#else
    PrintFile(w, "testfile", "from testPrint");
    remove("testfile");
#endif
}
